// PILabServerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PILabServer.h"
#include "PILabServerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CPILabServerApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CPILabServerDlg dialog

CPILabServerDlg::CPILabServerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPILabServerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPILabServerDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPILabServerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPILabServerDlg)
	DDX_Control(pDX, IDC_LIST1, m_Log);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPILabServerDlg, CDialog)
	//{{AFX_MSG_MAP(CPILabServerDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_LBN_DBLCLK(IDC_LIST1, OnDblclkList1)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



bool CPILabServerDlg::IsWorking(CSessionThread *thread)
{
	CDevice *dev = FindDevice(thread);
	if(dev != NULL)
	{
		return dev->Busy;
	}
	else
	{
		return false;
	}
}

CDevice* CPILabServerDlg::FindDevice(BYTE addr)
{
	for(UINT i=0;i<Devices.GetCount();i++)
	{
		CDevice *dev = Devices.Item(i);
		if(dev->RSAddress == addr)
			return dev;
	}
	return NULL;
}

CDevice* CPILabServerDlg::FindDevice(CString name)
{
	for(UINT i=0;i<Devices.GetCount();i++)
	{
		CDevice *dev = Devices.Item(i);
		if(dev->Name == name)
			return dev;
	}
	return NULL;
}

CDevice* CPILabServerDlg::FindDevice(CSessionThread *thread)
{
	for(UINT i=0;i<Devices.GetCount();i++)
	{
		CDevice *dev = Devices.Item(i);
		if(dev->workingThread == thread)
			return dev;
	}
	return NULL;
}

/////////////////////////////////////////////////////////////////////////////
// CPILabServerDlg message handlers

BOOL CPILabServerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	Destroying = false;
	hMapFile = NULL;
	hMapFile = CreateFileMapping((HANDLE)0xFFFFFFFF,
           		NULL,PAGE_READWRITE,0,0xFFFF,"PILabSystemFile");

	RSDLL = NULL;
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	connections = 0;
	Connected = false;
	ListenSocket.Parent = this;

	/////////////////////////////////////////////
        	char    drive[_MAX_DRIVE],dir[_MAX_DIR],fname[_MAX_FNAME],ext[_MAX_EXT];
        	char    path[_MAX_PATH];

        	GetModuleFileName(0,path,_MAX_PATH);
        	_splitpath( path, drive, dir, fname, ext );
     	sprintf(ProFile,"%s%s%s",drive,dir,"pilabserver.ini");
	//*****************************************************
	sprintf(fname, "%s%s%s",drive,dir,"rs485.dll");
	RS485 = NULL;
    RSDLL = (HINSTANCE)LoadLibrary("rs485.dll");
    if(RSDLL != NULL)
    {
        RS485 = (FUNCTION1)GetProcAddress(RSDLL, "Comm485");
        if(RS485 == NULL)
        {
            RS485 = (FUNCTION1)GetProcAddress(RSDLL, "_Comm485");
        }

        if(RS485 == NULL)
        {
            FreeLibrary(RSDLL);
            RSDLL = NULL;
	        return FALSE;
        }
        else
        {
            RS485(_ID_SYSTEM_MAIN_WINDOW_, (UINT)m_hWnd);
            RS485(_ID_COMMAND_INITIALIZE_, 0);
            goto RSDLL_loaded;
        }
    }
    else
    {
        return FALSE;
    }
	//*****************************************************
RSDLL_loaded:

	NICardBusy = false;

	UINT devices = GetPrivateProfileInt("SYSTEM","Devices", 0,ProFile);
	for(UINT i=0;i<devices;i++)
	{
		char section[25];
		sprintf(section,"Device%d",i);
		char name[512];
		GetPrivateProfileString(section,"Name","",name,512,ProFile);
		bool usecard;
		sprintf(section, "%s", name);
		if(GetPrivateProfileInt(section,"UseNICard", 0,ProFile) == 1)
			usecard = true;
		else
			usecard = false;
		CDevice *newDevice = new CDevice(name, usecard);
		GetPrivateProfileString(section,"ModuleName","",name,512,ProFile);
		newDevice->moduleName = CString(name);
		newDevice->RSAddress = GetPrivateProfileInt(section, "RSAddress", 0, ProFile);

		Devices.Add(newDevice);
	}


	Port = GetPrivateProfileInt("SYSTEM","Port", 7777,ProFile);
	Listen(1);
	/////////////////////////////////////////////

	TimerId = SetTimer(1,100,NULL);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}
BOOL	CPILabServerDlg::Listen(int flag)
{
	if(flag == 1)
	{
		ListenSocket.Create(Port,SOCK_STREAM,NULL);
		ListenSocket.AsyncSelect(FD_READ | FD_WRITE | FD_OOB | FD_ACCEPT | FD_CONNECT | FD_CLOSE );

		if( ListenSocket.Listen(5) == TRUE)
		{
			Connected = true;
			return TRUE;
		}
		else
		{
		Connected = false;
			return FALSE;
		}
	}
	else
	{
		ListenSocket.Close();
		Connected = false;
		return TRUE;
	}
}
// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPILabServerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPILabServerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CPILabServerDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
//	CDialog::OnCancel();
	theApp.Exit(0);
}

void CPILabServerDlg::OnOK() 
{
	// TODO: Add extra validation here
	
//	CDialog::OnOK();
}

void CPILabServerDlg::OnDestroy() 
{
	CDialog::OnDestroy();

	Clear();
//	theApp.Exit(0);
	
}
void CPILabServerDlg::DestroyThread(CSessionThread* &thread)
{
LogString("DestroyThread start");
	DWORD dwStatus;
	bool	workThread=false;
	CDevice *dev = NULL;

	if(!Destroying)
	{
		dev = FindDevice(thread);
		if(dev != NULL)
		{
			if(dev->Busy)
			{
				workThread = true;
			}
		}
	}

	do
	{
		VERIFY(::GetExitCodeThread(thread->m_hThread, &dwStatus));
		if(dwStatus == STILL_ACTIVE)
		{
//			thread->CloseAll();
			thread->terminate = true;
		}
		else
		{
			delete thread;
			thread = NULL;
			if(workThread)
			{
				if(dev != NULL)
				{
					dev->Busy = false;
					dev->workingThread = NULL;
					if(dev->useNICard && NICardBusy)
						NICardBusy = false;
				}
/*				for(UINT i=0;i<Sessions.GetCount();i++)
				{
					CSessionThread *thread = Sessions[i];
				}
*/
			}
		}
		MSG msg;
			::GetMessage(&msg, NULL, 0, 0/*, PM_REMOVE*/);
			::DispatchMessage(&msg);
			::TranslateMessage(&msg);
	}while(dwStatus == STILL_ACTIVE);
LogString("DestroyThread end");
}

LRESULT CPILabServerDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	switch(message)
	{
	case WM_TIMER:
		if(wParam == TimerId)
		{
			bool	_nicardbusy=false;
			for(UINT i=0;i<Sessions.GetCount();i++)
			{
				DWORD dwStatus;
				CSessionThread *thread = Sessions[i];
				VERIFY(::GetExitCodeThread(thread->m_hThread, &dwStatus));
				if(dwStatus == STILL_ACTIVE)
				{
					//***************************
//LogString("dwStatus == STILL_ACTIVE");
					if(thread->m_pMainWnd != NULL)
					{
						CUserDlg *sWnd = (CUserDlg*)(thread->m_pMainWnd);
						switch(sWnd->Status)
						{
						case usTimeout:
						case usDisconnect:
							{
//LogString("case usDisconnect");
								CDevice *dev = FindDevice(sWnd->deviceName);
								if(dev != NULL)
								{
									if(dev->Busy)
									{
//LogString("case dev->Busy = false");
//LogString("case dev->workingThread = NULL");
										dev->Busy = false;
										dev->workingThread = NULL;
									}

								}
								thread->terminate = true;
							}
							break;
						case usWorking:
							{
								CDevice *dev = FindDevice(sWnd->deviceName);
								if(dev != NULL)
								{
									if(dev->useNICard)
										_nicardbusy = true;
								}
							}
							break;
						case usDataSending:
							{
								CDevice *dev = FindDevice(sWnd->deviceName);
								if(dev != NULL)
								{
								}
							}
							break;
						case usWaiting:
							{
								CDevice *dev = FindDevice(sWnd->deviceName);
								if(dev != NULL)
								{
									if(!dev->Busy)
									{
										if(dev->useNICard)
										{
											if(NICardBusy)
											{
												break;
											}
											else
											{
												NICardBusy = true;
											}
										}

										dev->Busy = true;
										dev->workingThread = thread;
										sWnd->SendMessage_(_ID_MESSAGE_READY_TO_WORK_,NULL,0);
										sWnd->Status = usWorking;
									}
								}
							}
							break;
						}
					}
					//***************************
				}
				else
				{
LogString("dwStatus != STILL_ACTIVE start");
								CDevice *dev = FindDevice(thread);
								if(dev != NULL)
								{
									if(dev->Busy)
									{
										dev->Busy = false;
										dev->workingThread = NULL;
//LogString("case dev->Busy = false");
//LogString("case dev->workingThread = NULL");
/*										if(dev->useNICard)
										{
											if(NICardBusy)
											{
												NICardBusy = false;
											}
											else
											{
											}
										}
*/
									}

								}
					Sessions.Delete(i);
					delete thread;
					thread = NULL;
LogString("dwStatus != STILL_ACTIVE end");
				}
			}

			if(!_nicardbusy && NICardBusy)
				NICardBusy = false;
		}
		break;
	case SM_ACCEPT:
		{
		CMSocket *socket = (CMSocket*)wParam;
		CSessionThread *newThread = new CSessionThread(this);//(CSessionThread*)AfxBeginThread(RUNTIME_CLASS(CSessionThread),0,CREATE_SUSPENDED);
		newThread->m_bAutoDelete = FALSE;
		int res = newThread->CreateThread(CREATE_SUSPENDED);
		if(res != 0)
		{
	
			SOCKADDR	socketAddr;
			int sockAddrLen = sizeof(socketAddr);
			
//			if(newThread->m_pMainWnd != NULL)
			{
//				CUserDlg *newUserWnd = (CUserDlg*)(newThread->m_pMainWnd);
				CSocket sConnected;
				if(socket->Accept(sConnected,&socketAddr,&sockAddrLen) == TRUE)
				{
					newThread->hConnectedSocket = sConnected.Detach();
					Sessions.Add(newThread);
					VERIFY(newThread->SetThreadPriority(THREAD_PRIORITY_IDLE));
					newThread->ResumeThread();
					connections++;
				}
				else
				{
					newThread->hConnectedSocket = INVALID_SOCKET;
					newThread->ExitInstance();
					delete newThread;
				}
			}
		}
		else
		{
			delete newThread;
		}
		}
		return 0;
	case WM_USER+_ID_COMMAND_USER_FREE_:
		{
LogString("WM_USER+_ID_COMMAND_USER_FREE_ start");
			CSessionThread *thread = (CSessionThread*)wParam;
			if(thread != NULL)
			{
				if(IsWorking(thread))
				{
					CUserDlg *sWnd = (CUserDlg*)(thread->m_pMainWnd);
					CDevice *dev = FindDevice(sWnd->deviceName);
					if(dev != NULL)
					{
						dev->Busy = false;
						if(dev->useNICard && NICardBusy)
							NICardBusy = false;
						dev->workingThread = NULL;
					}
				}
			}
LogString("WM_USER+_ID_COMMAND_USER_FREE_ end");
		}
		return 0;
	case WM_USER+_ID_COMMAND_SHUTDOWN_:
		{
		theApp.Exit(0);
		}
		return 0;
	case WM_USER+_ID_COMMAND_LISTEN_:
		if(wParam != NULL)
		{
			Listen((int)wParam);
		}
		else
		{
				if(hMapFile != NULL)
				{
					LPVOID buffer = MapViewOfFile(hMapFile,FILE_MAP_READ,0,0,0xFFFF);

					UINT listen;
					memcpy(&listen, buffer, sizeof(UINT));
					UnmapViewOfFile(buffer);
					Listen((int)listen);
				}
		}
		return 0;
	case WM_USER+_ID_COMMAND_RESTART_:
		Listen(0);
		Listen(1);
		return 0;
	case WM_USER+_ID_COMMAND_GET_USERS_:
		{
			_PtrArray<CUserInfo> *Info;
//			_PtrArray<CUserInfo> Info1;
			if(wParam != NULL)
			{
				Info = (_PtrArray<CUserInfo>*)wParam;
			}
			else
			{
				Info = new _PtrArray<CUserInfo>(); 
			}

				for(UINT i=0;i<Sessions.GetCount();i++)
				{
					DWORD dwStatus;
					CSessionThread *thread = Sessions[i];
					VERIFY(::GetExitCodeThread(thread->m_hThread, &dwStatus));
					if(dwStatus == STILL_ACTIVE)
					{
						if(thread->m_pMainWnd != NULL)
						{
							CUserDlg *sWnd = (CUserDlg*)(thread->m_pMainWnd);
	
							CUserInfo *newInfo = new CUserInfo();
							newInfo->SetName(sWnd->Name.GetBuffer(0));
							CString address;
							UINT port;
							sWnd->Socket.GetPeerName(address, port);
							newInfo->SetAddress(address.GetBuffer(0));
							newInfo->SetStatus(sWnd->Status);
							newInfo->SetStatusName(plUserStatusNames[sWnd->Status]);
							newInfo->SetModuleName(sWnd->deviceName.GetBuffer(0));
							Info->Add(newInfo);
						}
					}
				}

			if(wParam != NULL)
			{
			}
			else
			{
				if(hMapFile != NULL)
				{
					LPVOID buffer = MapViewOfFile(hMapFile,FILE_MAP_WRITE,0,0,0xFFFF);

					UINT count = (UINT)(Info->GetCount());
					memcpy(buffer, &count, sizeof(UINT));
					UINT	offset = sizeof(UINT);
					for(i=0;i<Info->GetCount();i++)
					{
						CUserInfo *user = Info->Item(i);
						offset = user->ToBuffer((BYTE*)buffer+offset);
						delete user;
					}
					Info->Clear();

					delete Info;

					UnmapViewOfFile(buffer);
				}
			}
		}
		return 0;
	case WM_USER+_ID_COMMAND_GET_LISTEN_:
		{
			UINT uiConnected;
				if(Connected)
				{
					uiConnected = 1;
				}
				else
				{
					uiConnected = 0;
				}
			if(wParam != NULL)
			{
				int *iPtr = (int*)wParam;
				*iPtr = uiConnected;
			}
			else
			{
				if(hMapFile != NULL)
				{
					LPVOID buffer = MapViewOfFile(hMapFile,FILE_MAP_WRITE,0,0,0xFFFF);

					memcpy(buffer, &uiConnected, sizeof(UINT));


					UnmapViewOfFile(buffer);
				}
			}
		}
		return 0;
	case WM_USER+_ID_COMMAND_GET_PORT_:
		{
			if(wParam != NULL)
			{
				*((UINT*)wParam) = Port;
			}
			else
			{
				if(hMapFile != NULL)
				{
					LPVOID buffer = MapViewOfFile(hMapFile,FILE_MAP_WRITE,0,0,0xFFFF);

					memcpy(buffer, &Port, sizeof(UINT));


					UnmapViewOfFile(buffer);
				}
			}
		}
		return 0;
	case WM_USER+_ID_COMMAND_SET_PORT_:
		Port = (UINT)wParam;
		return 0;
	case WM_USER+_ID_COMMAND_GET_DEVICES_:
		{
			if(wParam != NULL)
			{
				UINT *iPtr = (UINT*)wParam;
				*iPtr = (UINT)Devices.GetCount();
			}
			else
			{
				if(hMapFile != NULL)
				{
					LPVOID buffer = MapViewOfFile(hMapFile,FILE_MAP_WRITE,0,0,0xFFFF);

					UINT count = (UINT)Devices.GetCount();
					memcpy(buffer, &count, sizeof(UINT));
					UnmapViewOfFile(buffer);
				}
			}
		return 0;
		}
	case WM_USER+_ID_COMMAND_GET_CONNECTIONS_:
		{
			if(wParam != NULL)
			{
				UINT *iPtr;
				iPtr = (UINT*)wParam;
				*((UINT*)wParam) = connections;
			}
			else
			{
				if(hMapFile != NULL)
				{
					LPVOID buffer = MapViewOfFile(hMapFile,FILE_MAP_WRITE,0,0,0xFFFF);

					memcpy(buffer, &connections, sizeof(UINT));
					UnmapViewOfFile(buffer);
				}
			}
		return 0;
		}
	case WM_USER+_ID_MESSAGE_WORK_REQUEST_://**********
		{
//LogString("_ID_MESSAGE_WORK_REQUEST_");
			UINT *result = (UINT*)wParam;
			SModuleInfo *mInfo = (SModuleInfo*)lParam;
			for(UINT i=0;i<Devices.GetCount();i++)
			{
				CDevice *Device = Devices.Item(i);
//LogString("_ID_MESSAGE_WORK_REQUEST_: mInfo->Name == " + mInfo->Name);
				if(Device->Name == mInfo->Name)
				{
					mInfo->moduleName = Device->moduleName;
//LogString("_ID_MESSAGE_WORK_REQUEST_: mInfo->moduleName == " + mInfo->moduleName);
					if(Device->Busy)
					{
//LogString("_ID_MESSAGE_WORK_REQUEST_ - Device->Busy == true");
						*result = 2;
						return 0;
					}
					else
					{
						if(Device->useNICard)
						{
							if(NICardBusy)
							{
//LogString("_ID_MESSAGE_WORK_REQUEST_ - NICardBusy == true");
								*result = 2;
								return 0;
							}
							else
							{
								NICardBusy = true;
							}
						}
						Device->Busy = true;
						Device->workingThread = mInfo->thread;
						*result = 1;
						return 0;
					}
				}
			}
			*result = 0;
		}
		return 0;
	case   _ID_RS485_MESSAGE_:
		{
LogString("_ID_RS485_MESSAGE_ start");
			switch((int)wParam)
			{
	        case errTIMEOUT:
				{
LogString("_ID_RS485_MESSAGE_  - errTIMEOUT");
					BYTE Address = (BYTE)lParam;
					CDevice *Device = FindDevice(Address);
					if(Device != NULL)
					{
						if(Device->workingThread != NULL)
						{
							CUserDlg *usrDlg = (CUserDlg*)(Device->workingThread->m_pMainWnd);
							if(usrDlg != NULL)
							{
								usrDlg->SendMessage(_ID_RS485_MESSAGE_, errTIMEOUT, Address);
							}
						}
					}
				}
				break;
	        case _ID_RS485_MESSAGE_:
				{
LogString("_ID_RS485_MESSAGE_  - _ID_RS485_MESSAGE_");
					CRS485Message *mes = (CRS485Message*)lParam;
					if(mes == NULL)
						break;

					BYTE Address = mes->GetAddress();
					CDevice *Device = FindDevice(Address);
					if(Device != NULL)
					{
						if(Device->workingThread != NULL)
						{
							CUserDlg *usrDlg = (CUserDlg*)(Device->workingThread->m_pMainWnd);
							if(usrDlg != NULL)
							{
								usrDlg->SendMessage(_ID_RS485_MESSAGE_, _ID_RS485_MESSAGE_, lParam);
							}
						}
					}
				}
				break;
			default:
LogString("_ID_RS485_MESSAGE_  - unknown message");
				break;
			}
LogString("_ID_RS485_MESSAGE_ end");
		}
		return 0;
	case _ID_RS485_LOGGING_MESSAGE_:
LogString("_ID_RS485_LOGGING_MESSAGE_ - "+CString((char*)wParam));
		return 0;
	case _ID_RS485_COMMAND_+_ID_COMMAND_OPEN_DEVICE_:
LogString("_ID_RS485_COMMAND_+_ID_COMMAND_OPEN_DEVICE_");
		if(RS485 != NULL)
		{
			RS485(_ID_COMMAND_OPEN_DEVICE_, (UINT)wParam);
		}
		return 0;
	case _ID_RS485_COMMAND_+_ID_COMMAND_CLOSE_DEVICE_:
LogString("_ID_RS485_COMMAND_+_ID_COMMAND_CLOSE_DEVICE_");
		if(RS485 != NULL)
		{
			RS485(_ID_COMMAND_CLOSE_DEVICE_, (UINT)wParam);
		}
		return 0;
	case _ID_RS485_COMMAND_+_ID_COMMAND_SEND_DATA_:
LogString("_ID_RS485_COMMAND_+_ID_COMMAND_SEND_DATA_");
		if(RS485 != NULL)
		{
			RS485(_ID_COMMAND_SEND_DATA_, (UINT)wParam);
		}
		return 0;
	case _ID_RS485_COMMAND_+_ID_COMMAND_SEND_DATA_RETRIEVE_:
LogString("_ID_RS485_COMMAND_+_ID_COMMAND_SEND_DATA_RETRIEVE_");
		if(RS485 != NULL)
		{
			RS485(_ID_COMMAND_SEND_DATA_RETRIEVE_, (UINT)wParam);
		}
		return 0;
	case _ID_RS485_COMMAND_+_ID_COMMAND_SEND_DATA_NEXT_:
LogString("_ID_RS485_COMMAND_+_ID_COMMAND_SEND_DATA_NEXT_");
		if(RS485 != NULL)
		{
			RS485(_ID_COMMAND_SEND_DATA_NEXT_, (UINT)wParam);
		}
		return 0;
	case _ID_RS485_COMMAND_+_ID_COMMAND_GET_DATA_:
LogString("_ID_RS485_COMMAND_+_ID_COMMAND_GET_DATA_");
		if(RS485 != NULL)
		{
			RS485(_ID_COMMAND_GET_DATA_, (UINT)wParam);
		}
		return 0;
	case _ID_DATA_STATUS_STRING_:
		LogString("_ID_DATA_STATUS_STRING_: "+CString((char*)wParam));
		return 0;
	}
	
	return CDialog::WindowProc(message, wParam, lParam);
}

void CPILabServerDlg::OnDblclkList1() 
{
	m_Log.ResetContent();	
}

void CPILabServerDlg::LogString(CString str)
{
	WINDOWPLACEMENT wPl;
	GetWindowPlacement(&wPl);
	if(wPl.showCmd != SW_HIDE)
	{
		m_Log.AddString(str);
		if(	m_Log.GetCount() > 100)
		{
			m_Log.DeleteString(0);
		}
	}
}

void CPILabServerDlg::OnClose() 
{
	Clear();
	
	CDialog::OnClose();
}

void CPILabServerDlg::Clear()
{
	for(UINT i=0;i<Sessions.GetCount();i++)
	{
			CSessionThread *thread = Sessions[i];
//			DestroyThread(thread);
			thread->terminate = true;
//			delete thread;
//			thread = NULL;
	}

	while(Sessions.GetCount()>0)
	{
		MSG msg;
			::GetMessage(&msg, NULL, 0, 0/*, PM_REMOVE*/);
			::DispatchMessage(&msg);
			::TranslateMessage(&msg);
	}

	Sessions.Clear();

	if(hMapFile != NULL)
	{
		CloseHandle(hMapFile);
        hMapFile = NULL;
	}

	if(RSDLL != NULL)
	{
		FreeLibrary(RSDLL);
		RSDLL = NULL;
	}

	Destroying = true;
	ListenSocket.Close();
	KillTimer(TimerId);


	for(i=0;i<Devices.GetCount();i++)
	{
		delete Devices.Item(i);
	}
	Devices.Clear();


	if(Connected)
	{
		ListenSocket.Close();
		Connected = false;
	}
}