// PILabServerDlg.h : header file
//

#if !defined(AFX_PILABSERVERDLG_H__B803B810_14D9_44FB_AA43_EDB8D041765F__INCLUDED_)
#define AFX_PILABSERVERDLG_H__B803B810_14D9_44FB_AA43_EDB8D041765F__INCLUDED_

#include "\cpp\arrays.h"
#include "SessionThread.h"
#include "\cpp\userinfo.h"
#include "\cpp\commands.h"
#include "..\pilabrs485\comm485.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CDevice
{
public:
	CDevice(CString	 devName, bool useCard)
	{
				Name = devName;
				useNICard=useCard;

				workingThread = NULL;
				moduleName = "";
				Busy = false;
	};
	~CDevice(){};

	CString			Name;
	bool			useNICard;
	UINT			RSAddress;

	CString			moduleName;
	CSessionThread	*workingThread;
	bool			Busy;
};

/////////////////////////////////////////////////////////////////////////////
// CPILabServerDlg dialog

class CPILabServerDlg : public CDialog
{
// Construction
public:
	CPILabServerDlg(CWnd* pParent = NULL);	// standard constructor


	UINT		TimerId;
	CMSocket	ListenSocket;
	char		ProFile[512];
	UINT		Port;
	bool		Connected;
	UINT		connections;

	bool		NICardBusy;
	_PtrArray<CSessionThread>	Sessions;
	_PtrArray<CDevice>			Devices;

	HANDLE		hMapFile;

	HINSTANCE	RSDLL;
	FUNCTION1	RS485;

	bool		Destroying;
	void		DestroyThread(CSessionThread* &thread);
	void		Clear();

	BOOL		Listen(int flag);

	bool		IsWorking(CSessionThread *thread);

	CDevice*	FindDevice(BYTE address);
	CDevice*	FindDevice(CString name);
	CDevice*	FindDevice(CSessionThread *thread);

	void		LogString(CString str);

// Dialog Data
	//{{AFX_DATA(CPILabServerDlg)
	enum { IDD = IDD_PILABSERVER_DIALOG };
	CListBox	m_Log;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPILabServerDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CPILabServerDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	virtual void OnCancel();
	virtual void OnOK();
	afx_msg void OnDestroy();
	afx_msg void OnDblclkList1();
	afx_msg void OnClose();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PILABSERVERDLG_H__B803B810_14D9_44FB_AA43_EDB8D041765F__INCLUDED_)
