// SessionThread.cpp : implementation file
//

#include "stdafx.h"
#include "PILabServer.h"
#include "SessionThread.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSessionThread

IMPLEMENT_DYNCREATE(CSessionThread, CWinThread)

CSessionThread::CSessionThread()
{
	hConnectedSocket = NULL;
}

CSessionThread::CSessionThread(CWnd *newParent)
{
	hConnectedSocket = NULL;
	Parent = newParent;
}

CSessionThread::~CSessionThread()
{
}

BOOL CSessionThread::InitInstance()
{

	m_pMainWnd = NULL;
	terminate = false;

	CUserDlg	*UserDlg = new CUserDlg();
	   if( UserDlg->CDialog::Create(IDD_USERDIALOG1,AfxGetMainWnd()) )
		{
			m_pMainWnd = UserDlg;
			if(hConnectedSocket != NULL)
			{
				UserDlg->Socket.Attach(hConnectedSocket);
				hConnectedSocket = INVALID_SOCKET;
			}
			return TRUE;
		}
		else
		{
			LPVOID lpMsgBuf;
			FormatMessage( 
				FORMAT_MESSAGE_ALLOCATE_BUFFER | 
				FORMAT_MESSAGE_FROM_SYSTEM | 
				FORMAT_MESSAGE_IGNORE_INSERTS,
				NULL,
				GetLastError(),
				MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
				(LPTSTR) &lpMsgBuf,
				0,
				NULL 
			);
			MessageBox( NULL, (LPCTSTR)lpMsgBuf, "Error", MB_OK | MB_ICONINFORMATION );
			LocalFree( lpMsgBuf );
			delete UserDlg;
			UserDlg = NULL;
		}

		m_pMainWnd = NULL;
		return FALSE;
}


void CSessionThread::CloseAll()
{
	try
	{
		if(m_pMainWnd != NULL)
		{
			CUserDlg *dlg = (CUserDlg*)m_pMainWnd;

			if(dlg->m_hWnd != NULL)
			{
				dlg->Close();
//			((CUserDlg*)m_pMainWnd)->Socket.ShutDown(2);
//			((CUserDlg*)m_pMainWnd)->Close();
//			((CUserDlg*)m_pMainWnd)->DestroyWindow();
				delete dlg;//->DestroyWindow();
			}
			m_pMainWnd = NULL;
		}
	}
	catch(...)
	{
			m_pMainWnd = NULL;
	}

/*	try
	{
			if(UserDlg != NULL)
			{
				//delete UserDlg;//((CUserDlg*)m_pMainWnd);
				UserDlg = NULL;
			}
	}
	catch(...)
	{
				UserDlg = NULL;
	}
*/
}
int CSessionThread::ExitInstance()
{
	try
	{
		CloseAll();
	}
	catch(...)
	{
			m_pMainWnd = NULL;
	}
	return CWinThread::ExitInstance();
}

BEGIN_MESSAGE_MAP(CSessionThread, CWinThread)
	//{{AFX_MSG_MAP(CSessionThread)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSessionThread message handlers

int CSessionThread::Run() 
{
	MSG msg;
	while(!terminate)
	{
		::GetMessage(&msg, NULL, 0, 0/*, PM_REMOVE*/);
		::DispatchMessage(&msg);
		::TranslateMessage(&msg);
	}

	return ExitInstance();
}

