//---------------------------------------------------------------------------

#include <vcl.h>
#include <inifiles.hpp>
#include <dir.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

typedef BOOL (*TGetModuleName)(LPSTR outString, UINT MaxLen);
typedef BOOL (*TGetModuleInfo)(LPSTR outString, UINT MaxLen);
typedef UINT (*TGetModuleChannels)(VOID);
typedef BOOL (*TGetModuleUseNICard)(VOID);
typedef UINT (*TGetModuleChannelInfo)(UINT chNumber, LPSTR outString, UINT MaxLen);
TGetModuleName  GetModuleName_;
TGetModuleInfo  GetModuleInfo;
TGetModuleUseNICard	GetModuleUseNICard;
TGetModuleChannels  GetModuleChannels;
TGetModuleChannelInfo   GetModuleChannelInfo;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
        	char    drive[_MAX_DRIVE],dir[_MAX_DIR],fname[_MAX_FNAME],ext[_MAX_EXT];
        	char    path[_MAX_PATH],file[_MAX_PATH];

        	GetModuleFileName(0,path,_MAX_PATH);
        	_splitpath( path, drive, dir, fname, ext );
     	sprintf(file,"%s%s%s",drive,dir,"pilabserver.ini");
	ProFile = AnsiString(file);

    TIniFile *IniFile = new TIniFile(ProFile);

    int Count = IniFile->ReadInteger("SYSTEM", "devices",0);
    for(int i=0;i<Count;i++)
    {
    	AnsiString s1 = "DEVICE"+AnsiString(i);
        AnsiString	name = IniFile->ReadString(s1, "Name","");
        if(name != "")
        {
            AnsiString moduleName = IniFile->ReadString(name, "moduleName","");
           	CDevice *newDev = RetrieveModuleInfo(moduleName.c_str());
            if(newDev != NULL)
            {
                newDev->RSAddress = IniFile->ReadInteger(name, "RSAddress",0);
	            RetrieveRealModuleChannels(newDev);
                Devices.Add(newDev);
            }
        }
    }

    delete IniFile;
	UpdateLists();

   OpenDialog1->Filter = "Modules (*.dll)|*.dll";
   OpenDialog1->FilterIndex = 1;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormDestroy(TObject *Sender)
{
		for(int i=0;i<Devices.GetCount();i++)
		{
			delete Devices.Item(i);
		}
		Devices.Clear();

}
//---------------------------------------------------------------------------
void __fastcall TForm1::ListBox1DrawItem(TWinControl *Control, int Index,
      TRect &Rect, TOwnerDrawState State)
{
AnsiString	String;
char	string[3][50],*str1,*str3;
int	offset=0;

    TListBox *ListBox = (TListBox*)Control;
    THeaderControl  *HeaderControl;
    if(ListBox == ListBox1)
        HeaderControl = HeaderControl1;
    else
    if(ListBox == ListBox2)
        HeaderControl = HeaderControl2;
    else
        return;

	TCanvas *Canvas = ListBox->Canvas;

    Canvas->FillRect(Rect);
    //sscanf(ListBox1->Items->Strings[Index].c_str(), "%s#%s#%s", port,from,to);

    int sections = HeaderControl->Sections->Count;
    str1 = new char[(ListBox->Items->Strings[Index]).Length()+1];
    memcpy(str1, ListBox->Items->Strings[Index].c_str(),sizeof(char)*(ListBox->Items->Strings[Index].Length()));
    str1[ListBox->Items->Strings[Index].Length()] = 0;
    strtok(str1, "#");
    sprintf(string[0], "%s", str1);
    str3 = strtok(NULL, "#");
    for(int i=1;i<sections;i++)
    {
            sprintf(string[i], "%s", str3);
            str3 = strtok(NULL, "#");
    }
    for(int i=0;i<sections;i++)
    {
            Canvas->TextOut(Rect.Left+offset, Rect.Top, AnsiString(string[i]));
            offset+= HeaderControl->Sections->Items[i]->Width;
    }
    delete str1;

}
//---------------------------------------------------------------------------
CDevice* __fastcall TForm1::RetrieveModuleInfo(char *FileName)
{
    CDevice *newDevice=NULL;
    UINT chCount = 0;
	HINSTANCE	DLL=NULL;

    char string[_MAX_DESCRIPTION_LEN_];

    bool	checkChannels=true;

	DLL = LoadLibrary(FileName);
	if(DLL != NULL)
	{
        newDevice = new CDevice();
		GetModuleName_ = (TGetModuleName)GetProcAddress(DLL, "GetModuleName");
		if(GetModuleName_ != NULL)
		{
            GetModuleName_(string, _MAX_DESCRIPTION_LEN_);
            newDevice->Name = AnsiString(string);
        }
        newDevice->moduleName = AnsiString(FileName);
        
		GetModuleInfo = (TGetModuleInfo)GetProcAddress(DLL, "GetModuleInfo");
		if(GetModuleInfo != NULL)
		{
            GetModuleInfo(string, _MAX_DESCRIPTION_LEN_);
            newDevice->Description = AnsiString(string);
        }

		GetModuleUseNICard = (TGetModuleUseNICard)GetProcAddress(DLL, "GetModuleUseNICard");
		if(GetModuleUseNICard != NULL)
        {
        	if(GetModuleUseNICard() == TRUE)
            {
	        	checkChannels = true;
	            newDevice->useNICard = true;
            }
            else
            {
	        	checkChannels = false;
	            newDevice->useNICard = false;
            }
        }


        if(checkChannels)
        {
			GetModuleChannels = (TGetModuleChannels)GetProcAddress(DLL, "GetModuleChannels");
			if(GetModuleChannels != NULL)
			{
            	chCount = GetModuleChannels();
	        }
    	    if(chCount > 0)
        	{
    			GetModuleChannelInfo = (TGetModuleChannelInfo)GetProcAddress(DLL, "GetModuleChannelInfo");
		    	if(GetModuleChannelInfo != NULL)
			    {
        	        for(UINT i=0;i<chCount;i++)
            	    {
                	    TChannel *newChannel = newDevice->Channels.Add();
	                    newChannel->Number = i;
    	                newChannel->RealNumber = -1;
        	            GetModuleChannelInfo(i, newChannel->Description, _MAX_DESCRIPTION_LEN_);
            	    }
	            }
	        }
        }

        FreeLibrary(DLL);
    }
    else
    {
			LPVOID lpMsgBuf;
			FormatMessage( 
				FORMAT_MESSAGE_ALLOCATE_BUFFER | 
				FORMAT_MESSAGE_FROM_SYSTEM | 
				FORMAT_MESSAGE_IGNORE_INSERTS,
				NULL,
				GetLastError(),
				MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
				(LPTSTR) &lpMsgBuf,
				0,
				NULL 
			);
			MessageBox( NULL, (LPCTSTR)lpMsgBuf, "Error", MB_OK | MB_ICONINFORMATION );
			LocalFree( lpMsgBuf );
    }
    return newDevice;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RetrieveRealModuleChannels(CDevice *Device)
{
    if(Device != NULL)
    {
        TIniFile *IniFile = new TIniFile(ProFile);
        if(IniFile!=NULL)
        {
            int Count = IniFile->ReadInteger(Device->Name, "Channels", 0);
            if(Count > Device->Channels.GetCount())
                Count = Device->Channels.GetCount();
            for(int i=0;i<Count;i++)
            {
                AnsiString Key = "ch"+AnsiString(i);
                Device->Channels.Item(i)->RealNumber = IniFile->ReadInteger(Device->Name, Key, -1);
            }
        }
        delete IniFile;
    }
}

void __fastcall TForm1::UpdateLists()
{
    int ItemIndex1 = ListBox1->ItemIndex;
    ListBox1->Clear();

    for(int i=0;i<Devices.GetCount();i++)
    {
        AnsiString String = AnsiString(Devices.Item(i)->Name)+"#"+AnsiString(Devices.Item(i)->Description);
        ListBox1->Items->Add(String);
    }
    if(ItemIndex1 == -1)
    {
        Button2->Enabled = false;
    }
    else
    {
        if(ItemIndex1 < ListBox1->Items->Count)
        {
            ListBox1->ItemIndex = ItemIndex1;
            Button2->Enabled = true;
        }
        else
        {
            Button2->Enabled = false;
        }
    }
    ListBox1->Repaint();
    UpdateChannelsList();
}
void __fastcall TForm1::UpdateChannelsList()
{
    int ItemIndex1 = ListBox1->ItemIndex;
    int ItemIndex2 = ListBox2->ItemIndex;
    ListBox2->Clear();
    if(ItemIndex1 != -1)
    {
        CDevice *Device = Devices.Item(ItemIndex1);
        Edit2->Text = AnsiString(Device->RSAddress);
        for(int i=0;i<Device->Channels.GetCount();i++)
        {
            if(Device->Channels.Item(i)->RealNumber != -1)
                ListBox2->Items->Add(AnsiString(Device->Channels.Item(i)->Number)+"#"+AnsiString(Device->Channels.Item(i)->Description)+"#"+AnsiString(Device->Channels.Item(i)->RealNumber));
            else
                ListBox2->Items->Add(AnsiString(Device->Channels.Item(i)->Number)+"#"+AnsiString(Device->Channels.Item(i)->Description)+"#none");
        }
        if(ItemIndex2 < ListBox2->Items->Count)
        {
            ListBox2->ItemIndex = ItemIndex2;
        }
    }
    ListBox2->Repaint();
    UpdateChannelEdit();
}

void __fastcall TForm1::UpdateChannelEdit()
{
    int ItemIndex2 = ListBox2->ItemIndex;
    int ItemIndex1 = ListBox1->ItemIndex;
    if(ItemIndex1 != -1)
    {
            Edit2->Enabled = true;
            BitBtn3->Enabled = true;
    }
    else
    {
            Edit2->Enabled = false;
            BitBtn3->Enabled = false;
    }
    if(ItemIndex2 == -1 || ItemIndex1 == -1)
    {
        Edit1->Enabled = false;
        BitBtn1->Enabled = false;
    }
    else
    {
       if(ItemIndex1 != -1)
       {
            CDevice *Device = Devices.Item(ItemIndex1);
            Edit1->Enabled = true;
            BitBtn1->Enabled = true;
            Edit1->Text = AnsiString(Device->Channels.Item(ItemIndex2)->RealNumber);
       }
       else
       {
       }
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ListBox1Click(TObject *Sender)
{
    if( ListBox1->ItemIndex != -1)
    {
        Button2->Enabled = true;
    }
    else
    {
        Button2->Enabled = false;
    }
    UpdateChannelsList();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::OnAddDevice(TObject *Sender)
{
    if(OpenDialog1->Execute())
    {
        CDevice *newDevice = RetrieveModuleInfo(OpenDialog1->FileName.c_str());
        if(newDevice != NULL)
        {
            RetrieveRealModuleChannels(newDevice);
            Devices.Add(newDevice);
            UpdateLists();
        }
}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::OnRemoveDevice(TObject *Sender)
{
    int ItemIndex1 = ListBox1->ItemIndex;
    if(ItemIndex1 != -1)
    {
    	delete Devices.Item(ItemIndex1);
        Devices.Delete(ItemIndex1);
        UpdateLists();
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::OnSave(TObject *Sender)
{
    char string[512];
    TIniFile *IniFile1 = new TIniFile(ProFile);
    int mCount = Devices.GetCount();
    IniFile1->WriteInteger("SYSTEM", "devices", mCount);
    for(int i=0;i<mCount;i++)
    {
        CDevice *Device = Devices.Item(i);

        IniFile1->WriteString("DEVICE"+AnsiString(i), "Name", Device->Name);
        IniFile1->WriteString(Device->Name, "Description", Device->Description);
        IniFile1->WriteString(Device->Name, "moduleName", Device->moduleName);
        IniFile1->WriteInteger(Device->Name, "RSAddress", Device->RSAddress);


        if(Device->useNICard)
        {
        	    int Count = Device->Channels.GetCount();
	            IniFile1->WriteInteger(Device->Name, "Channels", Count);
    	        for(int j=0;j<Count;j++)
        	    {
            	    AnsiString Key = "ch"+AnsiString(j);
                	IniFile1->WriteInteger(Device->Name, Key, Device->Channels.Item(j)->RealNumber);
	            }
		}
        else
        {
	            IniFile1->WriteInteger(Device->Name, "Channels", 0);
        }
    }
    delete IniFile1;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ListBox2Click(TObject *Sender)
{
    UpdateChannelEdit();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::OnSetChannel(TObject *Sender)
{
    int ItemIndex2 = ListBox2->ItemIndex;
    int ItemIndex1 = ListBox1->ItemIndex;

    CDevice *Device = Devices.Item(ItemIndex1);
    Device->Channels.Item(ItemIndex2)->RealNumber = Edit1->Text.ToInt();
    UpdateChannelsList();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::OnSetRSAddress(TObject *Sender)
{
    int ItemIndex1 = ListBox1->ItemIndex;
    CDevice *Device = Devices.Item(ItemIndex1);
    Device->RSAddress = Edit2->Text.ToInt();
}
//---------------------------------------------------------------------------

