// UserDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PILabServer.h"
#include "UserDlg.h"

#include "\cpp\commands.h"
#include "..\pilabrs485\comm485.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

void	LogMessage(LPSTR string)
{
	FILE *file = fopen("pilabserver.txt", "a+");
	fprintf(file, "%s\n",string);
	fclose(file);
}


/////////////////////////////////////////////////////////////////////////////
// CUserDlg dialog


CUserDlg::CUserDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUserDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUserDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CUserDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUserDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CUserDlg, CDialog)
	//{{AFX_MSG_MAP(CUserDlg)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//---------------------------------------------------------------------------
void CUserDlg::Queue_CanSend()
{
//char dstr[512];
//sprintf(dstr, "Queue_CanSend()");
//LogMessage(dstr);

	OutQueue.Buisy = false;
	if(OutQueue.GetCount()>0)
	{
		TCPDataStruct *Mes = OutQueue.Pop();
		delete Mes;
	}
	Queue_Send();
}
//-----------------------------------------------------
void CUserDlg::Queue_Send()
{
//char dstr[512];
//sprintf(dstr, "Queue_CanSend()");
//int busy;
//if(OutQueue.Buisy)
//	busy = 1;
//else
//	busy = 0;
//sprintf(dstr, "Queue_Send(). OutQueue.Buisy == %d, Count == %d", busy, OutQueue.GetCount());
//LogMessage(dstr);
	if(!OutQueue.Buisy)
	{
		if(OutQueue.GetCount() > 0)
		{
			TCPDataStruct *Mes = OutQueue.Peek();
			SendStruct(Mes);
			OutQueue.Buisy = true;
		}
	}
}
//-----------------------------------------------------
void CUserDlg::SendStruct_Queue(TCPDataStruct* Data)
{
	OutQueue.Push(Data);

	Queue_Send();
}
//-----------------------------------------------------
void CUserDlg::SendStruct(TCPDataStruct* Data)
{
	if(Data == NULL)
		return;

	int Len = _TCP_HEADER_SIZE_+sizeof(BYTE)*(Data->dataLen);
	
	BYTE *buffer = (BYTE*)calloc(Len, sizeof(BYTE));
	
	memcpy(buffer,&(Data->funcId),sizeof(int));
	int offset = sizeof(int);
	
	memcpy(buffer+offset,&(Data->dataLen),sizeof(int));
	offset += sizeof(int);
	
	memcpy(buffer+offset,&(Data->controlSumm),sizeof(long));
	offset += sizeof(long);
	
	if(Data->dataLen > 0)
		memcpy(buffer+offset, Data->data, Data->dataLen);
	OutBuffer.Write( buffer,Len );
	::PostMessage(m_hWnd,SM_SEND,0,0);

	free(buffer);

	Timer = 0;
}
//-----------------------------------------------------
void CUserDlg::SendMessage_(UINT FuncId, BYTE *buffer, UINT Len)
{
//char dstr[512];
//int busy;
//if(OutQueue.Buisy)
//	busy = 1;
//else
//	busy = 0;
//sprintf(dstr, "SendMessage_: FuncID == %d, buffer == %s, OutQueue.Busy == %d, OutQueue.Count == %d", FuncId, (char*)buffer, busy, OutQueue.GetCount());
//LogMessage(dstr);

	TCPDataStruct* Data = new TCPDataStruct();
	Data->funcId = FuncId;
	Data->data = new BYTE[Len];
	Data->dataLen = Len;
	if(Len > 0)
		memcpy(Data->data, buffer, Len);
	Data->CalcControlSum();
	SendStruct(Data);
	delete Data;
}
//-----------------------------------------------------
void CUserDlg::SendMessage_Queue(UINT FuncId, BYTE *buffer, UINT Len)
{
//char dstr[512];
//int busy;
//if(OutQueue.Buisy)
//	busy = 1;
//else
//	busy = 0;
//sprintf(dstr, "SendMessage_Queue : FuncID == %d, buffer == %s, OutQueue.Busy == %d, OutQueue.Count == %d", FuncId, (char*)buffer, busy, OutQueue.GetCount());
//LogMessage(dstr);

	TCPDataStruct* Data = new TCPDataStruct();
	Data->funcId = FuncId;
	Data->data = new BYTE[Len];
	Data->dataLen = Len;
	if(Len > 0)
		memcpy(Data->data, buffer, Len);
	Data->CalcControlSum();
	SendStruct_Queue(Data);
	//delete Data;
}
//-----------------------------------------------------
void CUserDlg::SendError(UINT Code)
{
	SendMessage_(_ID_MESSAGE_ERROR_, (BYTE*)(&Code), sizeof(UINT));
}
//-----------------------------------------------------
void CUserDlg::SendOK()
{
	SendMessage_(_ID_MESSAGE_OK_, NULL, 0);
}
/////////////////////////////////////////////////////////////////////////////
// CUserDlg message handlers
void CUserDlg::Clear()
{
	for(UINT i=0;i<OutQueue.GetCount();i++)
	{
		delete OutQueue.Item(i);
	}
	OutQueue.Clear();

	InBuffer.Clear();
	OutBuffer.Clear();

	if(Parameters != NULL)
	{
		delete[] Parameters;
		Parameters = NULL;
	}

	KillTimer(TimerId);

	if(DLL != NULL)
	{
		FUNCTION1 Func = (FUNCTION1)GetProcAddress(DLL,"MainProc");
		if(Func != NULL)
		{
			Func(_ID_SYSTEM_UNINITIALIZE_, 0);
		}
		FreeLibrary(DLL);
		DLL = NULL;
	}
}

void CUserDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	Close();
}

void CUserDlg::Close()
{
//	Socket.ShutDown(2);
	try
	{
		if(Socket.m_hSocket != NULL)
		{
//			Socket.Detach();
			Socket.Close();
		}
	}
	catch(...)
	{
		Socket.m_hSocket = NULL;
	}

	Clear();
}

LRESULT CUserDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	switch(message)
	{
	//*************		Messages from module
	case _ID_COMMAND_SEND_ERROR_:
		{
//char dstr[128];
//sprintf(dstr, "_ID_COMMAND_SEND_ERROR_ from module");
//LogMessage(dstr);
			SendError((UINT)wParam);
		}
		return 0;
	case _ID_DATA_GRAPH_:
		{
			Timer = 0;
			Status = usDataSending;
			SendMessage_Queue(_ID_DATA_GRAPH_,(BYTE*)wParam, (UINT)lParam);
		}
		return 0;
	case _ID_COMMAND_EXPERIMENT_END_:
		{
			Timer = 0;
			Status = usDataSending;
			SendMessage_Queue(_ID_COMMAND_EXPERIMENT_END_,NULL, 0);
			FreeDevice();
		}
		return 0;
	case _ID_DATA_STATUS_STRING_:
		{
			Timer = 0;
			SendMessage_Queue(_ID_DATA_STATUS_STRING_,(BYTE*)wParam, (UINT)lParam);
//char dstr[128],str2[512];
//memcpy(str2, (BYTE*)wParam, (int)lParam);
//str2[(int)lParam] = 0;
//sprintf(dstr, "_ID_DATA_STATUS_STRING_ == %s", str2);
//LogMessage(dstr);
//			Queue_CanSend();
		}
		return 0;
	case _ID_RS485_COMMAND_+_ID_COMMAND_OPEN_DEVICE_:
	case _ID_RS485_COMMAND_+_ID_COMMAND_CLOSE_DEVICE_:
	case _ID_RS485_COMMAND_+_ID_COMMAND_SEND_DATA_:
	case _ID_RS485_COMMAND_+_ID_COMMAND_SEND_DATA_RETRIEVE_:
	case _ID_RS485_COMMAND_+_ID_COMMAND_SEND_DATA_NEXT_:
	case _ID_RS485_COMMAND_+_ID_COMMAND_GET_DATA_:
		{
			CSessionThread *myThread = (CSessionThread*)AfxGetThread();
			myThread->Parent->SendMessage(message,wParam,lParam);
		}
		break;
	//*************		Timer Messages
	case WM_TIMER:
		if(wParam == TimerId)
		{
			Timer++;
			if(Timer > _SESSION_TIMEOUT_)
			{
				Status = usTimeout;
			}
		}
		else
		{
			if(wParam == SendTimer)
			{
//				::PostMessage(m_hWnd,SM_SEND,0,0);
//				Queue_CanSend();
			}
		}
		return 0;
	//*************		Socket Messages
	case SM_CLOSE:
		FreeDevice();
		Status = usDisconnect;
		return 0;
	case SM_RECEIVE:
		{
			BYTE *buffer = new BYTE[_BLOCK_SIZE_];
			int bytes = Socket.Receive(buffer,_BLOCK_SIZE_,0);

			InBuffer.Write(buffer, bytes);
			TCPDataStruct *Data=NULL;
			while( GetMessageStruct(&InBuffer, Data))//************
			{
				Timer = 0;
				switch(Data->funcId)
				{
				case _ID_MESSAGE_OK_:
					{
//CSessionThread *myThread = (CSessionThread*)AfxGetThread();
//char str[512];
//sprintf(str, "_ID_MESSAGE_OK_");
//myThread->Parent->SendMessage(_ID_DATA_STATUS_STRING_,(WPARAM)(str),0);
//LogMessage(str);
						Queue_CanSend();
						Errors = 0;
					}
					goto clear_n_exit;
				case _ID_MESSAGE_ERROR_:
					Queue_Send();
					goto clear_n_exit;
	 			case _ID_MESSAGE_CLOSE_REQUEST_:
					FreeDevice();
					Status = usDisconnect;
					goto clear_n_exit;
				}

				Errors = 0;
				switch(Status)
				{
				case usIdle://***********************************************
					switch(Data->funcId)
					{
					case _ID_COMMAND_USER_NAME_:
						{
							int len = Data->dataLen;
							char *str = new char[len + 1];
							memcpy(str,Data->data,len);
							str[len] = 0;
							Name = CString(str);
							delete[] str;
							Status = usConnecting;
							SendOK();
						}
						goto clear_n_exit;
					default:
						SendError(_ID_COMMAND_USER_NAME_);
						goto clear_n_exit;
					}
					break;
				case usConnecting://***********************************************
					switch(Data->funcId)
					{
					case _ID_COMMAND_USER_PASS_:
						{
							int len = Data->dataLen;
							char *str = new char[len + 1];
							memcpy(str,Data->data,len);
							str[len] = 0;
							Pass = CString(str);
							//**********************
							if(Name == "Admin" && Pass == "7777")
							{
								Status = usAdministrator;
								SendMessage_(_ID_MESSAGE_ADMINMODE_,NULL,0);
							}
							else
							{
								Status = usConnected;
								SendOK();
							}
							delete[] str;
							goto clear_n_exit;
						}
						break;
					default:
						SendError(_ID_COMMAND_USER_PASS_);
						break;
					}
					break;
				case usConnected://***********************************************
					switch(Data->funcId)
					{
					case _ID_MESSAGE_WORK_REQUEST_:
						{
//char dstr[128];
							CSessionThread *myThread = (CSessionThread*)AfxGetThread();
							int offset;
							UINT len = (UINT)(Data->data[0]);
							offset = 1;
							char *str = new char[len + 1];
							memcpy(str,Data->data+offset,len);
							offset+=len;
							str[len] = 0;
							deviceName = CString(str);
							delete[] str;

							memcpy(&len, Data->data+offset, sizeof(UINT));
							len += sizeof(UINT);
							if(len > 0)
							{
								Parameters = new BYTE[len];
								memcpy(Parameters,Data->data+offset,len);
								offset+=len;
							}
/*{
			char str1[4];
			CString aBuffer="";
			for(UINT i=0;i<len;i++)
			{
				int len = sprintf(str1, "%x ", Parameters[i]);
				if(len == 2)
				{
					str1[3] = 0;
					str1[2] = str1[1];
					str1[1] = str1[0];
					str1[0] = '0';
				}
				aBuffer += CString(str1);
			}
			FILE *file = fopen("DataBuffer.txt","a+");
    		fprintf(file, "DataBuffer1 = '%s'\n", aBuffer.GetBuffer(0));
			fclose(file);
//::SendMessage(MainWindow, _ID_DATA_STATUS_STRING_, (WPARAM)str, (LPARAM)strlen(str));
}
*/

							UINT	result=0;
							SModuleInfo mInfo;
							mInfo.thread = myThread;
							mInfo.Name = deviceName;
							myThread->Parent->SendMessage(WM_USER+_ID_MESSAGE_WORK_REQUEST_,(WPARAM)(&result),(LPARAM)(&mInfo));
							switch(result)
							{
							case 1:
								{
//sprintf(dstr, "SendMessage(WM_USER+_ID_MESSAGE_WORK_REQUEST_) returned 1");
//myThread->Parent->SendMessage(_ID_DATA_STATUS_STRING_,(WPARAM)(dstr),0);
									DLLName = mInfo.moduleName;
//sprintf(dstr, "SendMessage(WM_USER+_ID_MESSAGE_WORK_REQUEST_) returned DLLName == %s", DLLName.GetBuffer(0));
//myThread->Parent->SendMessage(_ID_DATA_STATUS_STRING_,(WPARAM)(dstr),0);
									SendOK();
									if(!Started)
										Start();
								}
								break;
							case 2:
								{
									sprintf(str, "usWaiting");
									SendMessage_Queue(_ID_DATA_STATUS_STRING_,(BYTE*)str, (UINT)strlen(str));									DLLName = mInfo.moduleName;
									Status = usWaiting;
									SendOK();
								}
								break;
							default:	//	invalid module name
								SendError(_ID_MESSAGE_WORK_REQUEST_);
								break;
							}
							Queue_CanSend();
						}
						break;
					}
					break;
				case usWaiting://***********************************************

					break;
				case usWorking://***********************************************
					switch(Data->funcId)
					{
					case _ID_COMMAND_EXPERIMENT_END_://_ID_COMMAND_EXPERIMENT_END_
						{
							FreeDevice();
							Status = usDisconnect;
						}
						break;
					default:
						SendError(_ID_COMMAND_EXPERIMENT_END_);
						break;
					}
					break;
				case usDataSending://***********************************************
					switch(Data->funcId)
					{
					case _ID_COMMAND_EXPERIMENT_END_://_ID_COMMAND_EXPERIMENT_END_
						{
							FreeDevice();
							Status = usDisconnect;
						}
						break;
					default:
						SendError(_ID_COMMAND_EXPERIMENT_END_);
						break;
					}
					break;
				case usDisconnect://***********************************************
					break;
				case usAdministrator://***********************************************
					{
						CSessionThread *myThread = (CSessionThread*)AfxGetThread();
						switch(Data->funcId)
						{
						case _ID_COMMAND_SHUTDOWN_:
							myThread->Parent->SendMessage(WM_USER+_ID_COMMAND_SHUTDOWN_,0,0);
							SendOK();
							break;
						case _ID_COMMAND_LISTEN_:
							myThread->Parent->SendMessage(WM_USER+_ID_COMMAND_LISTEN_,(WPARAM)(Data->data[0]),0);
							SendOK();
							break;
						case _ID_COMMAND_RESTART_:
							myThread->Parent->SendMessage(WM_USER+_ID_COMMAND_RESTART_,0,0);
							SendOK();
							break;
						case _ID_COMMAND_GET_USERS_:
							{
								_PtrArray<CUserInfo> Info;
								myThread->Parent->SendMessage(WM_USER+_ID_COMMAND_GET_USERS_,(WPARAM)(&Info),0);

								UINT len = sizeof(UINT);
								UINT Count = (UINT)Info.GetCount();
								for(UINT i=0;i<Count;i++)
								{
									len += Info.Item(i)->GetLen();
								}
								
								BYTE *buffer = new BYTE[len];

								memcpy(buffer, &Count, sizeof(UINT));
								UINT offset = sizeof(UINT);
								for(i=0;i<Count;i++)
								{
									CUserInfo *uInfo = Info.Item(i);
						
									offset += uInfo->ToBuffer(buffer+offset);

									delete uInfo;
								}
								
								SendMessage_(_ID_MESSAGE_USERS_,buffer,len);

								delete[] buffer;
							}
							break;
						case _ID_COMMAND_GET_PORT_:
							{
								UINT iValue;
								myThread->Parent->SendMessage(WM_USER+_ID_COMMAND_GET_PORT_,(WPARAM)(&iValue),0);
								SendMessage_(_ID_MESSAGE_PORT_,(BYTE*)&iValue,sizeof(UINT));
							}
							goto clear_n_exit;
							break;
						case _ID_COMMAND_SET_PORT_:
							{
								UINT newPort;
								memcpy(&newPort, Data->data, sizeof(UINT));
								myThread->Parent->SendMessage(WM_USER+_ID_COMMAND_SET_PORT_,(WPARAM)newPort,0);
							SendOK();
							}
							break;
						case _ID_COMMAND_GET_LISTEN_:
							{
								int iValue;
								myThread->Parent->SendMessage(WM_USER+_ID_COMMAND_GET_LISTEN_,(WPARAM)(&iValue),0);
								SendMessage_(_ID_MESSAGE_LISTEN_,(BYTE*)&iValue,sizeof(int));
							}
							goto clear_n_exit;
							break;
						default:
							SendError(_ID_UNKNOWN_COMMAND_);
							break;
						}
					}
					break;
				}//***********************************************

			}
clear_n_exit:
			if(Data != NULL)
				delete Data;
			delete[] buffer;
		}
		return 0;
	case SM_SEND:
		{
			//User->Timeout = 0;//***********
			while(OutBuffer.GetCount() > 0)
			{
				BYTE buffer[_BLOCK_SIZE_];
				int len = OutBuffer.Peek(buffer,_BLOCK_SIZE_);
				if(Socket.Send(buffer,len,0) == len)
				{
					OutBuffer.Delete(len);
				}
				else
				{
					int error = GetLastError();
				}
			}
		}
		return 0;
	case SM_ERROR:
		Status = usDisconnect;
		return 0;

	//*************		Command Messages
	case _ID_MESSAGE_READY_TO_WORK_:

		if(!Started)
			Start();

		return 0;

	//*************		RS485 Messages
	case   _ID_RS485_MESSAGE_:
		if(DLL != NULL)
		{
//char dstr[512];
//CSessionThread *myThread = (CSessionThread*)AfxGetThread();
			FUNCTION1 Func = (FUNCTION1)GetProcAddress(DLL,"MainProc");
			if(Func != NULL)
			{
				switch((int)wParam)
				{
				case errTIMEOUT:
//sprintf(dstr, "UsrDlg - _ID_RS485_MESSAGE_ - errTIMEOUT");
//myThread->Parent->SendMessage(_ID_DATA_STATUS_STRING_,(WPARAM)(dstr),0);
					Func(_ID_RS485_MESSAGE_, 0);
					break;
				case _ID_RS485_MESSAGE_:
//sprintf(dstr, "UsrDlg - _ID_RS485_MESSAGE_ - _ID_RS485_MESSAGE_");
//myThread->Parent->SendMessage(_ID_DATA_STATUS_STRING_,(WPARAM)(dstr),0);
					Func(_ID_RS485_MESSAGE_, (UINT)lParam);
					break;
				}
			}
		}
		return 0;
	}
	
	return CDialog::WindowProc(message, wParam, lParam);
}

BOOL CUserDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	Socket.Parent = this;
	OutQueue.Buisy = false;
	Errors = 0;
	Status = usIdle;
	Name = "";
	Parameters = NULL;

	Started = false;
	DLLName = "";
	DLL = NULL;

	Timer = 0;
	TimerId = SetTimer(2,1000,NULL);

//	SendTimer = SetTimer(3, 1000, NULL);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CUserDlg::Start()
{
	if(Started)
		return;

	Started = true;
//CSessionThread *myThread = (CSessionThread*)AfxGetThread();
char str[128];
sprintf(str, "usWorking");
//myThread->Parent->SendMessage(_ID_DATA_STATUS_STRING_,(WPARAM)(str),0);
SendMessage_Queue(_ID_DATA_STATUS_STRING_,(BYTE*)str, (UINT)strlen(str));
	
	Status = usWorking;

	if(DLL == NULL)
	{
		DLL = LoadLibrary(DLLName.GetBuffer(0));
	}
	
	if(DLL != NULL)
	{
		FUNCTION1 Func = (FUNCTION1)GetProcAddress(DLL,"MainProc");
		if(Func != NULL)
		{
			Func(_ID_SYSTEM_MAIN_WINDOW_, (UINT)m_hWnd);
			if( Func(_ID_COMMAND_EXPERIMENT_START_, (UINT)Parameters) != 0)
			{
//sprintf(str, "Func(_ID_COMMAND_EXPERIMENT_START_, (UINT)Parameters) != 0");
//myThread->Parent->SendMessage(_ID_DATA_STATUS_STRING_,(WPARAM)(str),0);
				SendError(_ID_COMMAND_EXPERIMENT_START_);
				Stop();
			}
			else
			{
//sprintf(str, "Func(_ID_COMMAND_EXPERIMENT_START_, (UINT)Parameters) == 0, experiment started");
//myThread->Parent->SendMessage(_ID_DATA_STATUS_STRING_,(WPARAM)(str),0);
			}
		}
		else
		{
			SendError(_ID_COMMAND_USER_MODULE_);
			Stop();
		}
	}
	else
	{
		SendError(_ID_COMMAND_USER_MODULE_);
		Stop();
	}
}

void CUserDlg::FreeDevice()
{
	if(DLL != NULL)
	{
		FUNCTION1 Func = (FUNCTION1)GetProcAddress(DLL,"MainProc");
		if(Func != NULL)
		{
			Func(_ID_SYSTEM_UNINITIALIZE_, 0);
		}
		FreeLibrary(DLL);
		DLL = NULL;
	}

	CSessionThread *myThread = (CSessionThread*)AfxGetThread();
	myThread->Parent->SendMessage(WM_USER+_ID_COMMAND_USER_FREE_,(WPARAM)(myThread),0);
}

void CUserDlg::Stop()
{
	FreeDevice();

	Status = usDisconnect;
}

BOOL CUserDlg::DestroyWindow() 
{
	Close();
	
	return CDialog::DestroyWindow();
}
