// circexp02.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "circexp02.h"
#include "circexpcdlg.h"
#include "imports.h"
#include "exports.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCircexp02App

BEGIN_MESSAGE_MAP(CCircexp02App, CWinApp)
	//{{AFX_MSG_MAP(CCircexp02App)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCircexp02App construction

CCircexp02App::CCircexp02App()
{
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CCircexp02App object

CCircexp02App theApp;

char		moduleName[]="circexp02s";
CString		Address="193.233.70.48";
UINT		Port=7779;
//CString		Address="v98";
//CString		Address="m619-3";
//UINT		Port=7777;


GRAPHFUNCTION1	GraphFunction=NULL;
HWND	m_hWndParent=NULL;

CString		UserName;
CString		UserPass;

BYTE	Params[1000];
int		ParamsLen;

int measureChannels=0;

CCircExpCDlg	*ExpDialog=NULL;

extern "C" __declspec(dllexport) BOOL MakeExperiment(LPSTR ServerAddress, UINT ServerPort, LPSTR Name, LPSTR Pass, 
													 BYTE *Switches,
													 SOURCE *Sources,
													 MEASUREPARAMS *Measure,
													 void *ProcFunc, HWND parentWindow)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	m_hWndParent = parentWindow;
	GraphFunction = (GRAPHFUNCTION1)ProcFunc;
	if(m_hWndParent == NULL && GraphFunction==NULL)
		return FALSE;

	if(Switches==NULL || Sources==NULL || Measure==NULL)
		return FALSE;


	if(ServerAddress != NULL)
		Address = CString(ServerAddress);
	if(ServerPort != 0)
		Port = ServerPort;

	UserName = CString(Name);
	UserPass = CString(Pass);

	//	filling parameters buffer

	ParamsLen = 0;
				//***********		Switches
	memcpy(Params+ParamsLen, Switches, 9);
	ParamsLen += 9;

	measureChannels = Measure->mChNum;
				//***********		Measure params
	memcpy(Params+ParamsLen, &(Measure->mChNum), sizeof(UINT));
	ParamsLen += sizeof(UINT);
	memcpy(Params+ParamsLen, Measure->mChs, sizeof(BYTE)*Measure->mChNum);
	ParamsLen += sizeof(BYTE)*Measure->mChNum;
	memcpy(Params+ParamsLen, &(Measure->PointsNum), sizeof(UINT));
	ParamsLen += sizeof(UINT);
	memcpy(Params+ParamsLen, &(Measure->PointsPerSec), sizeof(UINT));
	ParamsLen += sizeof(UINT);

	//***********		Sources
	{
		Params[ParamsLen] = Sources->Type;
		ParamsLen += 1;
		switch(Sources->Type)
		{
		case _SIGNALS_TYPE_NONE_:
			break;
		case _SIGNALS_TYPE_PULSE_:
			{
				Signal_Pulse *Signal = (Signal_Pulse*)(Sources->data);
				memcpy(Params+ParamsLen, &(Signal->T0), sizeof(double));
				ParamsLen += sizeof(double);
				memcpy(Params+ParamsLen, &(Signal->Y0), sizeof(double));
				ParamsLen += sizeof(double);
				Params[ParamsLen] = Sources->Recycle;
				ParamsLen += 1;
			}
			break;
		case _SIGNALS_TYPE_SQUARE_:
			{
				Signal_Square	*Signal = (Signal_Square*)(Sources->data);
				memcpy(Params+ParamsLen, &(Signal->T), sizeof(double));
				ParamsLen += sizeof(double);
				memcpy(Params+ParamsLen, &(Signal->T0), sizeof(double));
				ParamsLen += sizeof(double);
				memcpy(Params+ParamsLen, &(Signal->Y0), sizeof(double));
				ParamsLen += sizeof(double);
				memcpy(Params+ParamsLen, &(Signal->T1), sizeof(double));
				ParamsLen += sizeof(double);
				Params[ParamsLen] = Sources->Recycle;
				ParamsLen += 1;
			}
			break;
		case _SIGNALS_TYPE_POLINOM_:
			{
				Signal_Polinom	*Signal = (Signal_Polinom*)(Sources->data);
				memcpy(Params+ParamsLen, &(Signal->T), sizeof(double));
				ParamsLen += sizeof(double);
				memcpy(Params+ParamsLen, &(Signal->N), sizeof(int));
				ParamsLen += sizeof(int);

				for(int j=0;j<Signal->N;j++)
				{
					memcpy(Params+ParamsLen, &(Signal->Tn[j]), sizeof(double));
					ParamsLen += sizeof(double);
					memcpy(Params+ParamsLen, &(Signal->Yn[j]), sizeof(double));
					ParamsLen += sizeof(double);
				}

				Params[ParamsLen] = Sources->Recycle;
				ParamsLen += 1;
			}
			break;
		case _SIGNALS_TYPE_SIN_:
			{
//FILE *file = fopen("DataBuffer.txt", "a+");
//fprintf(file, "Signal_Sine\n");
				Signal_Sine	*Signal = (Signal_Sine*)(Sources->data);
//fprintf(file, "Y = %f\n", Signal->Y);
//fprintf(file, "F = %f\n", Signal->F);
//fprintf(file, "Fi = %f\n", Signal->Fi);
				memcpy(Params+ParamsLen, &(Signal->F), sizeof(double));
				ParamsLen += sizeof(double);
				memcpy(Params+ParamsLen, &(Signal->Y), sizeof(double));
				ParamsLen += sizeof(double);
				memcpy(Params+ParamsLen, &(Signal->Fi), sizeof(double));
				ParamsLen += sizeof(double);
				Params[ParamsLen] = Sources->Recycle;
				ParamsLen += 1;
//fclose(file);
			}
			break;
		}
	}
	ExpDialog = new CCircExpCDlg();
	ExpDialog->DoModal();
	int result = ExpDialog->ExpResult;
	delete ExpDialog;
	ExpDialog = NULL;
	if(result == 0)
		return TRUE;
	else
		return FALSE;

/*	if(ExpDialog->Create(IDD_CIRCEXPCDLG_DIALOG, NULL) != 0)
	{
		theApp.m_pMainWnd = ExpDialog;
		ShowWindow(ExpDialog->m_hWnd, SW_SHOW);
		if(ExpDialog->Start() != TRUE)
		{
			theApp.DoExit();
			return FALSE;
		}
	}
	else
		return FALSE;
*/
	return TRUE;
}

int CCircexp02App::ExitInstance() 
{
	DoExit();
	
	return CWinApp::ExitInstance();
}

void CCircexp02App::DoExit()
{

	if(ExpDialog != NULL)
	{
		delete ExpDialog;
		ExpDialog = NULL;
	}

}
