// circexp02s.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "circexp02s.h"
#include "\cpp\commands.h"
#include "CircExp02SDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//			AFX_MANAGE_STATE(AfxGetStaticModuleState());


extern "C" __declspec(dllexport) UINT MainProc(UINT command, UINT Param);
extern "C" __declspec(dllexport) BOOL GetModuleName(LPSTR outString, UINT MaxLen);
extern "C" __declspec(dllexport) BOOL GetModuleInfo(LPSTR outString, UINT MaxLen);
extern "C" __declspec(dllexport) UINT GetModuleChannels(VOID);
extern "C" __declspec(dllexport) BOOL GetModuleUseNICard(VOID);
extern "C" __declspec(dllexport) BOOL GetModuleChannelInfo(UINT chNumber, LPSTR outString, UINT MaxLen);

char		moduleName[]="circexp02s";

char		moduleInfo[]="Electrotechnics: circuits";
UINT		channelsNumber=11;
char		*channelInfo[11]={"Channel 0",
								"Channel 1",
								"Channel 2",
								"Channel 3",
								"Channel 4",
								"Channel 5",
								"Channel 6",
								"Channel 7",
								"Channel 8",
								"Channel 9",
								"Channel 10"};



FUNCTION1	MainFunction=NULL;
HWND		MainWindow=NULL;

CCircExp02SDlg	*ExpWnd = NULL;
char		ProFile[_MAX_PATH];

//************************************************************************
void DisplayLastError(
    LPSTR szAPI // pointer to Ansi function name
    )
{
    LPSTR MessageBuffer;
    DWORD dwBufferLength;

    fprintf(stderr,"%s error!\n", szAPI);

    if(dwBufferLength=FormatMessageA(
            FORMAT_MESSAGE_ALLOCATE_BUFFER |
            FORMAT_MESSAGE_FROM_SYSTEM,
            NULL,
            GetLastError(),
            MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
            (LPSTR) &MessageBuffer,
            0,
            NULL
            ))
    {
		char title[128];
		sprintf(title,"Error: %s", szAPI);
		::MessageBox(NULL,MessageBuffer,title,MB_OK);
        LocalFree(MessageBuffer);
    }
}


//*************************************************
BOOL GetModuleName(LPSTR outString, UINT MaxLen)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	UINT Len = strlen(moduleName);
	if(Len+1 > MaxLen)
	{
		Len = MaxLen-1;
	}
	memcpy(outString, moduleName, Len);
	outString[Len] = 0;
	return TRUE;
}
//*************************************************
BOOL GetModuleInfo(LPSTR outString, UINT MaxLen)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	UINT Len = strlen(moduleInfo);
	if(Len+1 > MaxLen)
	{
		Len = MaxLen-1;
	}
	memcpy(outString, moduleInfo, Len);
	outString[Len] = 0;
	return TRUE;
}
//*************************************************
BOOL GetModuleUseNICard(VOID)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	return TRUE;
}
//*************************************************
UINT GetModuleChannels(VOID)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	return channelsNumber;
}
//*************************************************
BOOL GetModuleChannelInfo(UINT chNumber, LPSTR outString, UINT MaxLen)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	UINT Len = strlen(channelInfo[chNumber]);
	if(Len+1 > MaxLen)
	{
		Len = MaxLen-1;
	}
	memcpy(outString, channelInfo[chNumber], Len);
	outString[Len] = 0;
	return TRUE;
}

//*************************************************
UINT MainProc(UINT command, UINT Param)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	try{

		switch(command)
		{
		case _ID_SYSTEM_MAIN_FUNCTION_:
			MainFunction = (FUNCTION1)Param;
			return 0;
		case _ID_SYSTEM_MAIN_WINDOW_:
			MainWindow = (HWND)Param;
			return 0;
		case _ID_SYSTEM_UNINITIALIZE_:
			{
				if(ExpWnd != NULL)
				{
					if(ExpWnd->m_hWnd != NULL)
					{
						ExpWnd->SendMessage(_ID_SYSTEM_UNINITIALIZE_, 0,0);
					}
					delete ExpWnd;
					ExpWnd = NULL;
				}
			}
			return 0;
		case _ID_COMMAND_EXPERIMENT_START_:
			{
        	char    drive[_MAX_DRIVE],dir[_MAX_DIR],fname[_MAX_FNAME],ext[_MAX_EXT];
        	char    path[_MAX_PATH];

        	GetModuleFileName(0,path,_MAX_PATH);
        	_splitpath( path, drive, dir, fname, ext );
	     	sprintf(ProFile,"%s%s%s",drive,dir,"pilabserver.ini");
				if(ExpWnd == NULL)
				{
					ExpWnd = new CCircExp02SDlg();
				   if(ExpWnd->Create(IDD_CIRCEXP02SDLG_DIALOG,NULL) == 0)
				   {
					   delete ExpWnd;
					   ExpWnd = NULL;
					   return -1;
				   }
				   else
				   {
				   }

				   ExpWnd->SendMessage(_ID_COMMAND_EXPERIMENT_START_, (WPARAM)Param,0);
				}
			}
			return 0;
		case _ID_RS485_MESSAGE_:
			{
				if(ExpWnd != NULL)
				{
					if(ExpWnd->m_hWnd != NULL)
					{
						if(Param == 0)
						{
							   ExpWnd->SendMessage(_ID_RS485_MESSAGE_, errTIMEOUT,0);
						}
						else
						{
							   ExpWnd->SendMessage(_ID_RS485_MESSAGE_, _ID_RS485_MESSAGE_, (LPARAM)Param);
						}
					}
				}
			}
			return 0;
		}
	}
	catch(...)
	{
	}
	return -1;
}
/////////////////////////////////////////////////////////////////////////////
// CCircexp02sApp

BEGIN_MESSAGE_MAP(CCircexp02sApp, CWinApp)
	//{{AFX_MSG_MAP(CCircexp02sApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCircexp02sApp construction

CCircexp02sApp::CCircexp02sApp()
{
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CCircexp02sApp object

CCircexp02sApp theApp;

BOOL CCircexp02sApp::InitApplication() 
{
	/////////////////////////////////////////////
	//*****************************************************
	
	return CWinApp::InitApplication();
}

int CCircexp02sApp::ExitInstance() 
{
	if(ExpWnd != NULL)
	if(ExpWnd->m_hWnd != NULL)
	{
		ExpWnd->DestroyWindow();
		delete ExpWnd;
		ExpWnd = NULL;
	}
	
	return CWinApp::ExitInstance();
}
