// Fifo.h: interface for the CFifo class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FIFO_H__5BEB8FA3_3294_11D4_9B09_707154C10000__INCLUDED_)
#define AFX_FIFO_H__5BEB8FA3_3294_11D4_9B09_707154C10000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#if !defined BYTE
typedef unsigned char BYTE;
#endif
#if !defined UINT
typedef unsigned int UINT;
#endif
#if !defined LPSTR
typedef char* LPSTR;
#endif
#if !defined NULL
#define NULL    0
#endif

class CFifo
{
private:
	BYTE *data;
	UINT	size;

	void	SaveData();
	void	ClearOld(void);
	BYTE	*oldData;
	UINT	oldSize;
public:
	CFifo();
	virtual ~CFifo();

	UINT	GetCount(void);
	void	SetSize(UINT);
	void	DeleteHead(void);
	void	Clear(void);

	BYTE	ReadByte(void);
	BYTE	PeekByte(void);
	UINT	WriteByte(BYTE);
	UINT	Read(BYTE *buffer, UINT MaxLen);
	UINT	Peek(BYTE *buffer, UINT MaxLen);
	UINT	Delete(UINT MaxLen);
	UINT	Write(BYTE* buffer, UINT Len);

	void	RemoveNonAlpha(void);
	UINT	PeekAlphaNumLine(LPSTR *buffer, UINT MaxLen);

	void	RemoveAlpha(void);
};

#endif // !defined(AFX_FIFO_H__5BEB8FA3_3294_11D4_9B09_707154C10000__INCLUDED_)
