#include "inpsignals.h"

CInputSignal::CInputSignal()
{
    Name = NULL;
	Data=0;
	Type=-1;
	_type=-1;
}

CInputSignal::CInputSignal(CInputSignal *Source)
{
    Name = NULL;
	Data=0;
	Type = Source->Type;
	switch(Type)
	{
	case _SIGNALS_TYPE_SIN_:
		SetData( new Signal_Sine((Signal_Sine*)(Source->GetData())) );
		break;
	case _SIGNALS_TYPE_POLINOM_:
		SetData(new Signal_Polinom((Signal_Polinom*)(Source->GetData())));
		break;
	case _SIGNALS_TYPE_SQUARE_:
		SetData(new Signal_Square((Signal_Square*)(Source->GetData())));
		break;
	case _SIGNALS_TYPE_PULSE_:
		SetData(new Signal_Pulse((Signal_Pulse*)(Source->GetData())));
		break;
	}
	_type=-1;
}

CInputSignal::~CInputSignal()
{
}

void CInputSignal::Clear()
{
	if(Type ==  _SIGNALS_TYPE_NONE_)
		ClearNAType();
freedata:
	switch(Type)
	{
	case _SIGNALS_TYPE_SIN_:
		delete ((Signal_Sine*)GetData());
		break;
	case _SIGNALS_TYPE_POLINOM_:
		delete ((Signal_Polinom*)GetData());
		break;
	case _SIGNALS_TYPE_SQUARE_:
		delete ((Signal_Square*)GetData());
		break;
	case _SIGNALS_TYPE_PULSE_:
		delete ((Signal_Pulse*)GetData());
		break;
	}
	Data = NULL;
	Type = -1;
}

void CInputSignal::SetNAType()
{
	_type = Type;
	Type = _SIGNALS_TYPE_NONE_;
}

UINT CInputSignal::ClearNAType()
{
	if(_type != -1)
	{
		Type = _type;
		_type = -1;
	}
	return Type;
}

UINT CInputSignal::GetNAType()
{
	return _type;
}

char* CInputSignal::GetName()
{
    return Name;
}

void CInputSignal::SetName(char *newName)
{
    if(Name != NULL)
    {
        delete Name;
        Name = NULL;
    }
    if(newName == NULL)
        return;
        
    int len = strlen(newName);
    if(len == 0)
        return;
    Name = new char[len+1];
    memcpy(Name,newName,len);
    Name[len] = 0;
}

//  SIGNALINFO class
/*SIGNALINFO::SIGNALINFO()
{
    Name=NULL;
    Data = NULL;
    Type = -1;
}

SIGNALINFO::SIGNALINFO(SIGNALINFO *Source)
{
    Name=NULL;
    Data = NULL;
    Type = -1;
    Assign(Source);
}

SIGNALINFO::~SIGNALINFO()
{
    Clear();
}

void SIGNALINFO::Assign(SIGNALINFO *Source)
{
    Clear();
    Type = Source->Type;
    SetName(Source->GetName());
    switch(Type)
    {
    case _SIGNALS_TYPE_NONE_:
        {
        }
        break;
   	case _SIGNALS_TYPE_PULSE_:
        {
            Signal_Pulse *newData = new Signal_Pulse();
            newData->Assign( (Signal_Pulse*)(Source->Data) );
            Data = (UINT)newData;
        }
        break;
   	case _SIGNALS_TYPE_SQUARE_:
        {
            Signal_Square *newData = new Signal_Square();
            newData->Assign( (Signal_Square*)(Source->Data) );
            Data = (UINT)newData;
        }
        break;
   	case _SIGNALS_TYPE_POLINOM_:
        {
            Signal_Polinom *newData = new Signal_Polinom();
            newData->Assign( (Signal_Polinom*)(Source->Data) );
            Data = (UINT)newData;
        }
        break;
   	case _SIGNALS_TYPE_SIN_:
        {
            Signal_Sine *newData = new Signal_Sine();
            newData->Assign( (Signal_Sine*)(Source->Data) );
            Data = (UINT)newData;
        }
        break;
    }
}

void    SIGNALINFO::Clear()
{
    try{
        if(Name != NULL)
        {
            delete  Name;
            Name = NULL;
        }
        if(Data != NULL)
        {
    		switch(Type)
    		{
	    	case _SIGNALS_TYPE_PULSE_:
		    	{
			    	delete (Signal_Pulse*)(Data);
    			}
	    		break;
    		case _SIGNALS_TYPE_SQUARE_:
	    		{
		    		delete (Signal_Square*)(Data);
			    }
    			break;
	    	case _SIGNALS_TYPE_POLINOM_:
		    	{
			    	delete (Signal_Polinom*)(Data);
    			}
	    		break;
		    case _SIGNALS_TYPE_SIN_:
			    {
    				delete (Signal_Sine*)(Data);
	    		}
		    	break;
    		}
            Type = -1;
            Data = NULL;
        }
	}
    catch(...)
    {
    }
}

char* SIGNALINFO::GetName()
{
    return Name;
}

void SIGNALINFO::SetName(char *newName)
{
    if(Name != NULL)
    {
        delete Name;
        Name = NULL;
    }
    if(newName == NULL)
        return;
        
    int len = strlen(newName);
    if(len == 0)
        return;
    Name = new char[len+1];
    memcpy(Name,newName,len);
    Name[len] = 0;
}
*/
