#ifndef _LAB_SERVER_COMMANDS_HEADER_INCLUDED_
#define _LAB_SERVER_COMMANDS_HEADER_INCLUDED_

//*******	CONSTANTS	**************
#ifndef M_PI
#define M_PI 3.1415926535897932384626433832795
//#define M_PI	3.1459
#endif

//*******	TYPES	******************
#ifndef _FUNCTION1_defined_
#define _FUNCTION1_defined_
typedef UINT (*FUNCTION1)(UINT Command, UINT Parameters);
#endif

typedef	struct tagAOParameters{
	BOOL	Infinite;		
	UINT	AllocationMode;
	BOOL	AllowRegeneration;
	LONG	NIterations;
	LONG	NUpdates;
	UINT	StartCondition;
	UINT	ClockSourceType;
	float	ClockFrequency;
	char	*ChannelString;
	float	UpperLimit;
	float	LowerLimit;
	UINT	RefType;
	UINT	ChannelType;
	}AOParameters,*pAOParameters;

typedef struct tagAIParameters{
	UINT	AllocationMode;
	LONG	NScans;
	char	*ChannelString;
	float	UpperLimit;
	float	LowerLimit;
	BYTE	InputMode;			//	CWAIInputModes
	BYTE	Coupling;			//	CWAICouplings
	LONG	ScanClock;
	UINT	ReturnDataType;
	}AIParameters,*pAIParameters;

typedef struct tagDAQData{
	VARIANT FAR*	Voltages;
	VARIANT FAR*	BinaryCodes;
	}DAQData,*pDAQData;

//***********************************
typedef struct tagMeasureParams{
	UINT	PointsNum;
	UINT	PointsPerSec;
	UINT	mChNum;
	BYTE	*mChs;
}MEASUREPARAMS;

typedef struct tagSourceStruct{
	BYTE	Type;
	UINT	data;
	BYTE	Recycle;
}SOURCE;
/////////////////////////////////////////////////////////////////////////////


#include "tcpdata.h"

#define	_SESSION_TIMEOUT_		20	//	seconds

//*******	COMMANDS	**************
#define	_ID_UNKNOWN_COMMAND_	0x0000

#define	_ID_COMMAND_SHUTDOWN_	0x0010
#define	_ID_COMMAND_LISTEN_		0x0011
#define	_ID_COMMAND_RESTART_	0x0012

#define	_ID_COMMAND_GET_USERS_	0x0100
#define	_ID_COMMAND_GET_PORT_	0x0101
#define	_ID_COMMAND_GET_LISTEN_	0x0102
#define	_ID_COMMAND_GET_DEVICES_		0x0103
#define	_ID_COMMAND_GET_CONNECTIONS_	0x0104

#define	_ID_COMMAND_SET_PORT_	0x0200

//******	messages
#define _ID_MESSAGE_OK_					0x0501
#define _ID_MESSAGE_ERROR_				0x0502
#define _ID_MESSAGE_STRING_				0x0503

#define _ID_MESSAGE_WAIT_				0x0504
#define _ID_MESSAGE_READY_TO_WORK_		0x0505
#define _ID_MESSAGE_CLOSE_REQUEST_		0x0506
#define _ID_MESSAGE_WORK_REQUEST_		0x0507
#define _ID_MESSAGE_ADMINMODE_			0x05A1
#define _ID_MESSAGE_LISTEN_				0x05A2
#define _ID_MESSAGE_PORT_				0x05A3
#define _ID_MESSAGE_USERS_				0x05A4


#define	_ID_COMMAND_USER_QUIT_	0x1100
#define	_ID_COMMAND_USER_NAME_	0x1101
#define	_ID_COMMAND_USER_PASS_	0x1102
#define	_ID_COMMAND_USER_MODULE_			0x1103
#define	_ID_COMMAND_USER_FREE_				0x1104
#define	_ID_COMMAND_EXPERIMENT_START_				0x1111
#define	_ID_COMMAND_EXPERIMENT_END_					0x1112

#define	_ID_SYSTEM_INITIALIZE_ 		0x1fff
#define	_ID_SYSTEM_UNINITIALIZE_ 		0x1ffe
#define	_ID_SYSTEM_MAIN_WINDOW_ 		0x2000
#define	_ID_SYSTEM_MAIN_FUNCTION_		0x2001
#define	_ID_SYSTEM_DIO_SET_LINES_		0x2002
#define	_ID_SYSTEM_DIO_SET_VALUE_		0x2003
#define	_ID_SYSTEM_DIO_GET_VALUE_		0x2004
#define	_ID_SYSTEM_AO_SET_PARAMETERS_	0x2011
#define	_ID_SYSTEM_AO_SET_WAVEFORM_		0x2012
#define	_ID_SYSTEM_AO_START_			0x2013
#define	_ID_SYSTEM_AO_RESET_			0x2014
#define	_ID_SYSTEM_AOPOINT_SET_VALUE_	0x2015
#define	_ID_SYSTEM_AOPOINT_SET_VALUED_	0x2016
#define	_ID_SYSTEM_AOPOINT_SET_PARAMS_	0x2017
#define	_ID_SYSTEM_AI_SET_PARAMETERS_	0x2021
#define	_ID_SYSTEM_AI_START_			0x2022
#define	_ID_SYSTEM_AI_STOP_				0x2023
#define	_ID_SYSTEM_RESET_ALL_			0x2050
#define	_ID_SYSTEM_LOG_MESSAGE_					0x2100
#define	_ID_SYSTEM_GET_MODULE_INFO_			0x2200
#define	_ID_SYSTEM_GET_MODULE_CHANNELS_		0x2201
#define	_ID_SYSTEM_GET_MODULE_CHANNEL_INFO_	0x2202

#define	_ID_COMMAND_SEND_OK_		0x5000
#define	_ID_COMMAND_SEND_STRING_	0x5002
#define	_ID_COMMAND_SEND_STRUCT_	0x5003
#define	_ID_COMMAND_SEND_MESSAGE_	0x5004
#define	_ID_COMMAND_SEND_ERROR_		0x5005
#define	_ID_COMMAND_SEND_OK_QUEUE_			0x5006
#define	_ID_COMMAND_SEND_STRING_QUEUE_		0x5007
#define	_ID_COMMAND_SEND_STRUCT_QUEUE_		0x5008
#define	_ID_COMMAND_SEND_MESSAGE_QUEUE_		0x5009
#define	_ID_COMMAND_SEND_ERROR_QUEUE_		0x5010

#define	_ID_RS485_COMMAND_			0x5100

#define _ID_DATA_GRAPH_				0x7001
#define _ID_DATA_DIO_VALUE_			0x7002
#define _ID_DATA_SIGNALS_			0x7003
#define _ID_DATA_PARAMETERS_			0x7004
#define _ID_DATA_STATUS_STRING_			0x7005

#define	_ID_MODULE_COMMAND_			0x00100000

#endif