#ifndef _INP_SIGNALS_H_INCLUDED_
#define _INP_SIGNALS_H_INCLUDED_

#include "Y:\include\interlab\cpp\labsignals.h"
#include "Y:\include\labdata.h"
#include "Y:\include\interlab\headers\commands.h"

typedef	UINT (*GENSIGNALFUNC1)(UINT	Type, void *Parameters, _LabData* &Data, long nPoints, double T);

#define ID_COMMAND_FREE         WM_USER+10      // before unload...  or just unload...
#define ID_COMMAND_LOADFORM     WM_USER+11
#define ID_COMMAND_SHOWFORM     WM_USER+12      //  Param = &(BYTE[2]), element[0] == left, element[1] == top
#define ID_COMMAND_HIDEFORM     WM_USER+13

class CInputSignal
{
private:
	UINT	Data;
	UINT	Type;
	UINT	_type;
	UINT	Point;
    char    *Name;
public:
	CInputSignal();
	CInputSignal(CInputSignal *Source);
	~CInputSignal();
	void Clear();

	void SetData(void *newData){Data = (UINT)newData;};
	UINT	GetData(){return Data;};
	void SetType(UINT newType){Type = newType;};
	UINT	GetType(){return Type;};
	void SetPoint(UINT newPoint){Point = newPoint;};
	UINT	GetPoint(){return Point;};

	void SetNAType();
	UINT	ClearNAType();
	UINT	GetNAType();

    char* GetName();
    void    SetName(char *newName);
};

class CInputSignalList : public _PtrList
{
private:
public:
	CInputSignalList():_PtrList(){};
	~CInputSignalList()
	{
		Clear();
	};

	void Clear()
	{
		while(GetCount()>0)
		{
			Delete(0);
		}
	};
	UINT Delete(UINT index)
	{
			delete Item(index);
			return _PtrList::Delete(index);
	};
//protected:
	CInputSignal* Item(UINT index)
	{
		return (CInputSignal*)(_PtrList::Item(index));
	};
};


class SIGNALINFO
{
private:
    char    *Name;

public:
    SIGNALINFO();
    SIGNALINFO(SIGNALINFO *Source);
    ~SIGNALINFO();

    void    Assign(SIGNALINFO*);
    void    Clear();

    UINT    Type;
    UINT    Data;

    char* GetName();
    void    SetName(char *newName);
};


//*************************************************
#endif

