#include "labsignals.h"

//**********    Classes **************************
//**********    Signal_Pulse    ******************
Signal_Pulse::Signal_Pulse()
{
}

Signal_Pulse::Signal_Pulse(Signal_Pulse *Source)
{
    Assign(Source);
}

void Signal_Pulse::Assign(Signal_Pulse *Source)
{
    T0=Source->T0;
    Y0=Source->Y0;
}

Signal_Pulse::~Signal_Pulse()
{
}

//**********    Signal_Square    ******************
Signal_Square::Signal_Square()
{
}

Signal_Square::~Signal_Square()
{
}

Signal_Square::Signal_Square(Signal_Square *Source)
{
        Assign(Source);
}
void Signal_Square::Assign(Signal_Square *Source)
{
        T=Source->T;T0=Source->T0;Y0=Source->Y0;T1=Source->T1;
}

//**********    Signal_Polinom    ******************
Signal_Polinom::Signal_Polinom()
{
    T=0.;
    N=0;
    Tn=NULL;
    Yn=NULL;
}

Signal_Polinom::Signal_Polinom(Signal_Polinom *Source)
{
    Tn=NULL;
    Yn=NULL;
    Assign(Source);
}

Signal_Polinom::~Signal_Polinom()
{
    Clear();
}

void Signal_Polinom::Assign(Signal_Polinom *Source)
{
        T=0.;
        N=0;
        T=Source->T;
        N=Source->N;
        if(N>0)
        {
            Tn = new double[N];
            Yn = new double[N];
            for(int i=0;i<N;i++)
            {
                Tn[i] = Source->Tn[i];
                Yn[i] = Source->Yn[i];
            }
        }
        else
        {
            Tn=NULL;
            Yn=NULL;
        }
}

void Signal_Polinom::Clear()
{
        T=0.;
        N=0;
        if(Tn!=NULL)
        {
            delete Tn;
            Tn=NULL;
        }
        if(Yn!=NULL)
        {
            delete Yn;
            Yn=NULL;
        }
}

//**********    Signal_Sine    ******************
Signal_Sine::Signal_Sine()
{
}

Signal_Sine::Signal_Sine(Signal_Sine *Source)
{
    Assign(Source);
}

Signal_Sine::~Signal_Sine()
{
}

void Signal_Sine::Assign(Signal_Sine *Source)
{
    F=Source->F;
    Fi=Source->Fi;
    Y=Source->Y;
}

//*********************************************
//**********    Functions    ******************
void GenerateSignal(int	Type, void *Parameters,
                    double* &x, double* &y,
                    long nPoints, double T, BYTE Recyle)
{
double	temp1;
long	i,p,j;

	double dx = T/(double)nPoints;
    x = new double[nPoints];
    y = new double[nPoints];

    switch(Type)
    {
    case _SIGNALS_TYPE_PULSE_:
	    for(i=0;i<nPoints;i++)
    	{
    		x[i] = dx*((double)i);
            if(x[i] < ((Signal_Pulse*)Parameters)->T0)
            	y[i] = 0.;
            else
            	y[i] = ((Signal_Pulse*)Parameters)->Y0;
        }
      	break;
    case _SIGNALS_TYPE_SQUARE_:
	    for(i=0,p=0;i<nPoints;i++)
    	{
    		x[i] = dx*((double)i);
            temp1 = x[i]-((double)p*((Signal_Square*)Parameters)->T);	//	 
            if(temp1 < ((Signal_Square*)Parameters)->T0)
            {
            	y[i] = 0.;
            }
            else
            {
            	if(temp1 < ((Signal_Square*)Parameters)->T1)
                {
	            	y[i] = ((Signal_Square*)Parameters)->Y0;
                }
                else
                {
	            	if(temp1 < ((Signal_Square*)Parameters)->T)
                    {
                    	y[i] = 0.;
                    }
                    else
                    {
                    	i--;
                        p++;
                    }
                }
            }
        }
       	break;
    case _SIGNALS_TYPE_POLINOM_:
	    for(i=0,p=0;i<nPoints;i++)
    	{
    		x[i] = dx*((double)i);
            temp1 = x[i]-((double)p*((Signal_Polinom*)Parameters)->T);	//	 
            for(j=0;j<((Signal_Polinom*)Parameters)->N;j++)
            {
            	if(temp1 <= ((Signal_Polinom*)Parameters)->Tn[j])
                {
	            	y[i] = ((Signal_Polinom*)Parameters)->Yn[j];
                    break;
                }
                else
                {
                	if( j == (((Signal_Polinom*)Parameters)->N - 1) )
                    {
                    	i--;
                        p++;
                    }
                }
            }
        }
       	break;
    case _SIGNALS_TYPE_SIN_:
        {
            double Fi = M_PI*((Signal_Sine*)Parameters)->Fi/180.;
        	temp1 = 2.*M_PI*(((Signal_Sine*)Parameters)->F);	//	2**

	        for(i=0;i<nPoints;i++)
    	    {
        		x[i] = dx*((double)i);
            	y[i] = (((Signal_Sine*)Parameters)->Y)*sin(temp1*x[i]+Fi);
            }
        }
    	break;
    }
}


