#ifndef _LAB_SIGNALS_
#define _LAB_SIGNALS_

#include <math.h>
#if !defined M_PI
#define M_PI 3.1415926535897932384626433832795
#endif

#if !defined BYTE
typedef unsigned char BYTE;
#endif

#define _SIGNALS_TYPE_NONE_		0xFF		//	none
#define _SIGNALS_TYPE_PULSE_	0x00		//	
#define _SIGNALS_TYPE_SQUARE_	0x01		//	 
#define _SIGNALS_TYPE_POLINOM_	0x02		//	 
#define _SIGNALS_TYPE_SIN_		0x03		//	

#define _SIGNALS_RECYCLE_TYPE_NONE_		0xFF
#define _SIGNALS_RECYCLE_TYPE_ALL_		0x01
#define _SIGNALS_RECYCLE_TYPE_LAST_		0x02

//	 
//	_SIGNALS_TYPE_IMPULSE_
class Signal_Pulse
{
public:
    Signal_Pulse();
    Signal_Pulse(Signal_Pulse *Source);
    void Assign(Signal_Pulse *Source);
    ~Signal_Pulse();
    double	T0;	//	
    double	Y0;	//	
};
//	_SIGNALS_TYPE_SQUARE_
class Signal_Square
{
public:
    Signal_Square();
    Signal_Square(Signal_Square *Source);
    ~Signal_Square();

    void Assign(Signal_Square *Source);
	double	T;	//	
    double	T0;	//	 
    double	Y0;	//	
    double	T1;	//	 
};
//	_SIGNALS_TYPE_POLINOM_
class Signal_Polinom
{
public:
    Signal_Polinom();
    Signal_Polinom(Signal_Polinom *Source);

    ~Signal_Polinom();

    void Assign(Signal_Polinom *Source);

    void    Clear();
	double	T;	//	
    int		N;	//	 
    double	*Tn;	//	 
    double	*Yn;	//	 
};
//	_SIGNALS_TYPE_SIN_
class Signal_Sine
{
public:
    Signal_Sine();
    Signal_Sine(Signal_Sine *Source);
    ~Signal_Sine();
    void Assign(Signal_Sine *Source);
	double	F;	//	, 
    double	Fi;	//	 , 
    double	Y;	//	
};

//	 

extern void GenerateSignal(int	Type, void *Parameters, double* &x, double* &y, long nPoints, double T, BYTE Recyle);

//extern void	DebugMessage(char *string);
#endif
