#include "stdafx.h"

#include "tcpdata.h"

TCPDataStruct::TCPDataStruct()
{
	data=NULL;
}
TCPDataStruct::~TCPDataStruct()
{
	if(data!=NULL)
	{
		delete[] data;
		data = NULL;
	}
}
void TCPDataStruct::CalcControlSum()
{
	controlSumm = 0;
	for(UINT i=0;i<dataLen;i++)
		controlSumm+=(long)(data[i]);
}

bool	GetMessageStruct(CFifo* Fifo, TCPDataStruct* &Data)
{
	if(Fifo->GetCount() < _TCP_HEADER_SIZE_)
		return false;
	BYTE *buffer = new BYTE[_TCP_HEADER_SIZE_];
	UINT Len = _TCP_HEADER_SIZE_;

	if(Fifo->Peek(buffer, Len) != Len)
	{
		delete[] buffer;
		return false;
	}

	Data = new TCPDataStruct();
	memcpy(&(Data->funcId),buffer,sizeof(int));
	int offset = sizeof(int);

	memcpy(&(Data->dataLen),buffer+offset,sizeof(int));
	offset+=sizeof(int);

	memcpy(&(Data->controlSumm),buffer+offset,sizeof(long));
	offset += sizeof(long);

	UINT MaxLen = _TCP_HEADER_SIZE_+Data->dataLen;
	if(Fifo->GetCount() < MaxLen)
	{
		delete[] buffer;
		delete Data;
		return false;
	}
	delete[] buffer;
	buffer = new BYTE[MaxLen];
	if(Fifo->Read(buffer,_TCP_HEADER_SIZE_) != _TCP_HEADER_SIZE_)
	{
		delete[] buffer;
		delete Data;
		return false;
	}
	Data->data = new BYTE[Data->dataLen];
	if(Fifo->Read(Data->data,Data->dataLen) != Data->dataLen)
	{
		delete[] buffer;
		delete Data;
		return false;
	}
	delete[] buffer;

	if(Data->controlSumm == GetControlSum(*Data))
		return true;
	else
	{
		delete Data;
		return false;
	}
}

long	GetControlSum(TCPDataStruct &Data)
{
	long controlSumm = 0;
	for(UINT i=0;i<Data.dataLen;i++)
		controlSumm+=(long)(Data.data[i]);
	return controlSumm;
}
