#include "stdafx.h"

#include "userinfo.h"

char *plUserStatusNames[9]={"Idle","Connecting...","Connected","Waiting...","Working...","DataSending...","Disconnecting...",
"Timeout","Administrator"};

CUserInfo::CUserInfo()
{
	name = NULL;
	sStatus = NULL;
	address = NULL;
	module = NULL;
	plStatus = usIdle;
}

CUserInfo::~CUserInfo()
{
	if(name != NULL)
	{
		delete[] name;
		name = NULL;
	}
	if(sStatus != NULL)
	{
		delete[] sStatus;
		sStatus = NULL;
	}
	if(module != NULL)
	{
		delete[] module;
		module = NULL;
	}
	if(address != NULL)
	{
		delete[] address;
		address = NULL;
	}
}

void __fastcall		CUserInfo::SetName(char *newName)
{
	if(name != NULL)
	{
		delete[] name;
	}

	if(newName == NULL)
	{
		name = NULL;
		return;
	}

	int len = strlen(newName);
	name = new char[len+1];
	if(len > 0)
		memcpy(name, newName, len);

	name[len] = 0;
}

char* __fastcall	CUserInfo::GetName()
{
	return name;
}

void __fastcall		CUserInfo::SetStatus(plUserStatus newStatus)
{
	plStatus = newStatus;
}

plUserStatus __fastcall	CUserInfo::GetStatus()
{
	return plStatus;
}


void __fastcall		CUserInfo::SetStatusName(char *newName)
{
	if(sStatus != NULL)
	{
		delete[] sStatus;
	}

	if(newName == NULL)
	{
		sStatus = NULL;
		return;
	}

	int len = strlen(newName);
	sStatus = new char[len+1];
	if(len > 0)
		memcpy(sStatus, newName, len);

	sStatus[len] = 0;
}

char* __fastcall	CUserInfo::GetStatusName()
{
	return sStatus;
}

void __fastcall		CUserInfo::SetModuleName(char *newName)
{
	if(module != NULL)
	{
		delete[] module;
	}

	if(newName == NULL)
	{
		module = NULL;
		return;
	}

	int len = strlen(newName);
	module = new char[len+1];
	if(len > 0)
		memcpy(module, newName, len);

	module[len] = 0;
}

char* __fastcall	CUserInfo::GetModuleName()
{
	return module;
}

void __fastcall		CUserInfo::SetAddress(char *newAddress)
{
	if(address != NULL)
	{
		delete[] address;
	}

	if(newAddress == NULL)
	{
		address = NULL;
		return;
	}

	int len = strlen(newAddress);
	address = new char[len+1];
	if(len > 0)
		memcpy(address, newAddress, len);

	address[len] = 0;
}

char* __fastcall	CUserInfo::GetAddress()
{
	return address;
}

UINT __fastcall	CUserInfo::GetLen()
{
	UINT res = 4*sizeof(UINT);
	if(name != NULL)
		res+=strlen(name);
	if(sStatus != NULL)
		res+=strlen(sStatus);
	if(module != NULL)
		res+=strlen(module);
	if(address != NULL)
		res+=strlen(address);
	res+=sizeof(plUserStatus);
	return res;
}

UINT	__fastcall	CUserInfo::ToBuffer(BYTE *buffer)
{
	UINT offset = 0;

	//name
	offset += StoreChToBuffer(name, buffer+offset);
	//address
	offset += StoreChToBuffer(address, buffer+offset);
	//module
	offset += StoreChToBuffer(module, buffer+offset);
	//sStatus
	offset += StoreChToBuffer(sStatus, buffer+offset);
	memcpy(buffer+offset, &plStatus, sizeof(plUserStatus));
	offset += sizeof(plUserStatus);
	return offset;
}

UINT	__fastcall	CUserInfo::StoreChToBuffer(char *str, BYTE *buffer)
{
	UINT	slen;
	UINT offset = 0;
	if(str != NULL)
	{
		slen = strlen(str);
		memcpy(buffer+offset, &slen, sizeof(UINT));
		offset+=sizeof(UINT);
		memcpy(buffer+offset, str, slen);
		offset+=slen;
	}
	else
	{
		slen = 0;
		memcpy(buffer+offset, &slen, sizeof(UINT));
		offset+=sizeof(UINT);
	}
	return offset;
}
UINT	__fastcall	CUserInfo::LoadChFromBuffer(char* &str, BYTE *buffer)
{
	UINT offset = 0;
	UINT	slen;

	if(str != NULL)
		delete[] str;
	memcpy(&slen, buffer, sizeof(UINT));
	offset+=sizeof(UINT);
	if(slen > 0)
	{
		str = new char[slen+1];
		memcpy(str, buffer+offset, slen);
		offset+=slen;
		str[slen] = 0;
	}
	else
	{
		str = NULL;
	}

	return offset;
}

UINT	__fastcall	CUserInfo::FromBuffer(BYTE *buffer)
{
	UINT offset = 0;

	//	name
	offset += LoadChFromBuffer(name, buffer);
	//address
	offset += LoadChFromBuffer(address, buffer+offset);
	//module
	offset += LoadChFromBuffer(module, buffer+offset);
	//sStatus
	offset += LoadChFromBuffer(sStatus, buffer+offset);
	memcpy(&plStatus, buffer+offset, sizeof(plUserStatus));
	offset += sizeof(plUserStatus);

	return offset;
}
