//---------------------------------------------------------------------------

#include <vcl.h>
#include <windows.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include "Unit1.h"

#include "\cpp\commands.h"
#include "\cpp\cwsafearray.h"
//#include "\cpp\cwdaqconst.h"

#pragma hdrstop

#pragma argsused
//---------------------------------------------------------------------------

FUNCTION1   MainFunction=NULL;
HWND		MainWindow=NULL;

TForm1 *Form1=NULL;

//---------------------------------------------------------------------------
BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fwdreason, LPVOID lpvReserved)
{
    switch(fwdreason)
    {
    case DLL_PROCESS_ATTACH:
    case DLL_THREAD_ATTACH:
        {
        	if(Form1 == NULL)
            {
            	Form1 = new TForm1(NULL);
            }
        }
        break;
    case DLL_PROCESS_DETACH:
    case DLL_THREAD_DETACH:
    	if(Form1 != NULL)
        {
        	Form1->Close();
            delete Form1;
            Form1 = NULL;
        }
        break;
    }
	return 1;
}
//---------------------------------------------------------------------------
extern "C" __declspec(dllexport) UINT plnidaq(UINT command, UINT Param)
{
    switch(command)
    {
    case _ID_SYSTEM_MAIN_FUNCTION_:
        MainFunction = (FUNCTION1)Param;
        return 0;
    case _ID_SYSTEM_MAIN_WINDOW_:
    	MainWindow = (HWND)Param;
        return 0;
	case _ID_SYSTEM_DIO_SET_LINES_:
    	if(Form1 != NULL)
        {
			Form1->CWDIO1->OutputPortList = "0";
			Form1->CWDIO1->Ports->Item(OleVariant(0))->set_Assignment(cwdioLineConfigured);
			Form1->CWDIO1->Ports->Item(OleVariant(0))->set_LineDirection((long)Param);
    	    Form1->CWDIO1->_Update();
        }
    	return 0;
	case _ID_SYSTEM_DIO_SET_VALUE_:
    	if(Form1 != NULL)
        {
//	    	Form1->CWDIO1->SingleWrite(OleVariant((int)Param));
	        Form1->CWDIO1->Ports->Item(OleVariant(0))->set_Value((long)Param);
    	    Form1->CWDIO1->_Update();
        }
    	return 0;
	case _ID_SYSTEM_DIO_GET_VALUE_:
    	if(Form1 != NULL)
    	{
//        	VARIANT	Value;
//	    	Form1->CWDIO1->SingleRead(&Value);
    	    Form1->CWDIO1->_Update();
	        *((BYTE*)Param) = (BYTE)Form1->CWDIO1->Ports->Item(OleVariant(0))->get_Value();
//            *((BYTE*)Param) = (BYTE)(Value.llVal);
        }
    	return 0;
	case _ID_SYSTEM_AO_SET_PARAMETERS_:
    	{
			AOParameters	*Parameters = (AOParameters*)Param;

			Form1->CWAO1->Reset();
			Form1->CWAO1->Device = 1;
            if(Parameters->Infinite == TRUE)
				Form1->CWAO1->Infinite = true;
            else
				Form1->CWAO1->Infinite = false;
			Form1->CWAO1->AllocationMode = Parameters->AllocationMode;//cwaoOnBoardFIFO;//
            if(Parameters->AllowRegeneration == TRUE)
				Form1->CWAO1->AllowRegeneration = true;
            else
				Form1->CWAO1->AllowRegeneration = false;
			Form1->CWAO1->NIterations = 1;//Parameters->NIterations;
			Form1->CWAO1->NUpdates = Parameters->NUpdates;

			Form1->CWAO1->StartCondition->set_Type((CWAOConditionTypes)Parameters->StartCondition);//cwaoAIStartTrigger);//

			Form1->CWAO1->IntervalClock->set_ClockSourceType(cwaoInternalCS);//(CWAOClockSources)Parameters->ClockSourceType);
			Form1->CWAO1->IntervalClock->set_InternalClockMode(cwaoFrequency);
			Form1->CWAO1->IntervalClock->set_Frequency((float)Parameters->ClockFrequency);
//			Form1->CWAO1->IntervalClock->set_Frequency(1000.);
			Form1->CWAO1->UpdateClock->set_ClockSourceType(cwaoInternalCS);//(CWAOClockSources)Parameters->ClockSourceType);
			Form1->CWAO1->UpdateClock->set_InternalClockMode(cwaoFrequency);
			Form1->CWAO1->UpdateClock->set_Frequency((float)Parameters->ClockFrequency);
//			Form1->CWAO1->UpdateClock->set_Frequency(1000.);

			Form1->CWAO1->Channels->RemoveAll();

            AnsiString astr1 = AnsiString(Parameters->ChannelString);
            int len = astr1.WideCharBufSize();
        	wchar_t *wchar = new wchar_t[len];
            astr1.WideChar(wchar,len);

			Form1->CWAO1->Channels->Add(wchar,
								OleVariant(Parameters->UpperLimit),
								OleVariant(Parameters->LowerLimit),
								OleVariant(Parameters->RefType),
								OleVariant(Parameters->ChannelType) );


			Form1->CWAO1->Configure();
        	delete[] wchar;
        }
    	return 0;
	case _ID_SYSTEM_AO_SET_WAVEFORM_:
    	{
			BYTE *buffer = (BYTE*)Param;

            int dimms = buffer[0];
            UINT Points;
            memcpy(&Points, buffer+1, sizeof(UINT));
            double *data = (double*)(buffer+1+sizeof(UINT));

			Variant	vData;
    		vData = Variant(OPENARRAY(int,(0,Points)),varDouble);
			for(UINT i=0;i<Points;i++)
	        {
    			vData.PutElement(data[i],i);
	        }
//            Variant vOptional = CreateOleObject("CWAOWriteSpec");
           	//vOptional.OlePropertySet("OutputDataType", cwaoScaledData);


            Form1->CWAO1->Write(vData);//,vOptional);
            vData.Clear();
        }
    	return 0;
	case _ID_SYSTEM_AO_START_:
    	Form1->CWAO1->Start();
    	return 0;
	case _ID_SYSTEM_AO_RESET_:
    	    Form1->CWAO1->Reset();
    	return 0;
	case _ID_SYSTEM_AOPOINT_SET_VALUE_:
			char string[10];
			sprintf(string, "%d", (int)(((BYTE*)Param)[0]) );
			Form1->CWAOPoint1->ChannelString = WideString(string);
			Form1->CWAOPoint1->SingleWrite(OleVariant( *((double*)(((BYTE*)Param)+1)) ),
												OleVariant( 1) );
//    	Form1->CWAOPoint1->SingleWrite( *((VARIANT*)Param), OleVariant(TRUE) );
    	return 0;
    case _ID_SYSTEM_AOPOINT_SET_VALUED_:
    	Form1->CWAOPoint1->SingleWrite( *((VARIANT*)Param), OleVariant(FALSE) );
    	return 0;
    case _ID_SYSTEM_AOPOINT_SET_PARAMS_:
    	return 0;
	case _ID_SYSTEM_AI_SET_PARAMETERS_:
    	{
			AIParameters	*Parameters = (AIParameters*)Param;
			Form1->CWAI1->AllocationMode = Parameters->AllocationMode;
			Form1->CWAI1->NScans = Parameters->NScans;
			Form1->CWAI1->ScanClock->set_ClockSourceType(cwaiInternalCS);
			Form1->CWAI1->ScanClock->set_InternalClockMode(cwaiFrequency);
			Form1->CWAI1->ScanClock->Frequency = (float)Parameters->ScanClock;

			Form1->CWAI1->StartCondition->set_Type(cwaiNoActiveCondition);
			Form1->CWAI1->StopCondition->set_Type(cwaiNoActiveCondition);

			Form1->CWAI1->Channels->RemoveAll();

            AnsiString astr1 = AnsiString(Parameters->ChannelString);
            int len = astr1.WideCharBufSize();
        	wchar_t *wchar = new wchar_t[len];
            astr1.WideChar(wchar,len);
			Form1->CWAI1->Channels->Add(wchar,
							OleVariant(Parameters->UpperLimit),
							OleVariant(Parameters->LowerLimit),
							OleVariant(Parameters->InputMode),
							OleVariant(Parameters->Coupling));
			Form1->CWAI1->ReturnDataType = Parameters->ReturnDataType;
			Form1->CWAI1->Configure();
            delete[] wchar;
        }
    	return 0;
	case _ID_SYSTEM_AI_START_:
    	Form1->CWAI1->Start();
    	return 0;
	case _ID_SYSTEM_AI_STOP_:
    	Form1->CWAI1->Stop();
    	return 0;
    case _ID_SYSTEM_UNINITIALIZE_:
    	if(Form1 != NULL)
        {
            Form1->Release();
            delete Form1;
            Form1 = NULL;
	    	CoUninitialize();
        }
    	return 0;
    case _ID_SYSTEM_INITIALIZE_:
    	CoInitialize(NULL);
       	if(Form1 == NULL)
        {
           	Form1 = new TForm1(NULL);
        }
    	return 0;
	case _ID_SYSTEM_RESET_ALL_:
    	if(Form1 != NULL)
        {
//	        Form1->CWDO1->Reset();
//	        Form1->CWDI1->Reset();

	    	Form1->CWDIO1->Reset();
            Form1->CWDIO1->Device = 1;

            Form1->CWAOPoint1->Reset();
            Form1->CWAOPoint1->Device = 1;
        	Form1->CWAI1->Reset();
    	    Form1->CWAO1->Reset();
            Form1->CWAO1->Device = 1;
        }
    	return 0;
    }

	return -1;
}
//---------------------------------------------------------------------------
