// OperExpCDlg.cpp : implementation file
//

#include "stdafx.h"
#include "operexp02c.h"
#include "OperExpCDlg.h"
#include "exports.h"
#include "\cpp\commands.h"
#include "\cpp\labdata.h"
#include "\cppprj_vs\tcpclient\tcpclientdefs.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



extern	COperexp02cApp theApp;
extern	COperExpCDlg	*ExpDialog;


extern	CString		Address;
extern	UINT		Port;


extern	GRAPHFUNCTION1	GraphFunction;
extern	HWND	m_hWndParent;

extern	CString		UserName;
extern	CString		UserPass;

extern	BYTE	Params[1000];
extern	int		ParamsLen;
extern char		moduleName[];

extern	int measureChannels;



BOOL ProcessFunction(UINT SocketId, UINT Message);


void	DebugMessage(char *string)
{
/*
	ExpDialog->m_Log.AddString(string);
	FILE	*debug = fopen("operexp02c.txt","a");
	if(debug != NULL)
	{
		fprintf(debug,"%s\n",string);
		fclose(debug);
	}
*/
}


/////////////////////////////////////////////////////////////////////////////
// COperExpCDlg dialog


COperExpCDlg::COperExpCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COperExpCDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(COperExpCDlg)
	//}}AFX_DATA_INIT
}


void COperExpCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COperExpCDlg)
	DDX_Control(pDX, IDC_PROGRESS1, m_Progress);
	DDX_Control(pDX, IDC_EDIT1, m_Status);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COperExpCDlg, CDialog)
	//{{AFX_MSG_MAP(COperExpCDlg)
	ON_WM_DESTROY()
	ON_LBN_DBLCLK(IDC_LIST1, OnDblclkList1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COperExpCDlg message handlers

BOOL COperExpCDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	SocketId = -1;
	connected = false;
	Cancelled = false;

	QueueBusy = false;
	complete = false;
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void COperExpCDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	while(Queue.GetCount() > 0)
	{
		delete Queue.Pop();
	}
	
}

void COperExpCDlg::OnCancel() 
{
	Cancelled = true;

	Stop();
	
	CDialog::OnCancel();
}

LRESULT COperExpCDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CDialog::WindowProc(message, wParam, lParam);
}

BOOL COperExpCDlg::Start()
{
		SocketId = CreateSocket((UINT)ProcessFunction);
		if(SocketId == -1)
		{
			return FALSE;
		}
		else
		{
			//****
			if(Connect(SocketId, Address.GetBuffer(0), Port) )
			{
	            m_Status.SetWindowText(" ");
				m_Progress.SetPos(2);
                connected = true;

				SendMessage_Queue(_ID_COMMAND_USER_NAME_, (BYTE*)(UserName.GetBuffer(0)), UserName.GetLength()+1);
				SendMessage_Queue(_ID_COMMAND_USER_PASS_, (BYTE*)(UserPass.GetBuffer(0)), UserPass.GetLength()+1);

				UINT nlen = strlen(moduleName);
				UINT bufLen = 1+nlen+sizeof(UINT)+ParamsLen;
				BYTE	*buffer = new BYTE[bufLen];
				buffer[0] = (BYTE)nlen;
				int offset = 1;
				memcpy(buffer+offset, moduleName, nlen);
				offset+=nlen;
				memcpy(buffer+offset, &ParamsLen, sizeof(UINT));
				offset+=sizeof(UINT);
				memcpy(buffer+offset, Params, ParamsLen);
				offset+=ParamsLen;

				SendMessage_Queue(_ID_MESSAGE_WORK_REQUEST_, buffer, bufLen);
				delete[] buffer;
			}
			else
			{
				DestroySocket(SocketId);
				SocketId = -1;
				return FALSE;
			}
		}
	return TRUE;
}

void COperExpCDlg::Stop()
{
	MSG msg;
	while(!Cancelled)
	{
		::GetMessage(&msg, NULL, 0, 0/*, PM_REMOVE*/);
		::DispatchMessage(&msg);
		::TranslateMessage(&msg);
	}

	if(connected)
	{
		if(SocketId != -1)
			DestroySocket(SocketId);
		connected = false;
	}

	UINT result;
	if(complete)
	{
		result = _ID_MESSAGE_OK_;
	}
	else
	{
		result = _ID_MESSAGE_ERROR_;
	}
	if(GraphFunction != NULL && m_hWndParent == NULL)
	{
		GraphFunction(result,NULL);
	}
	else
		if(m_hWndParent != NULL)
		{
			::PostMessage(m_hWndParent,WM_USER+result,0,0);
		}

}


//---------------------------------------------------------------------------
void COperExpCDlg::QueueCanSend()
{
	QueueBusy = false;
	if(Queue.GetCount()>0)
	{
		delete Queue.Pop();
	}
	Queue_Send();
}
//-----------------------------------------------------
void COperExpCDlg::Queue_Send()
{
	if(connected)
	if(!QueueBusy)
	{
		if(Queue.GetCount() > 0)
		{
			TCPDataStruct *Mes = Queue.Peek();
			if(Mes != NULL)
			{
				SendStruct(Mes);
			}
			QueueBusy = true;
		}
	}
}

//-----------------------------------------------------
void COperExpCDlg::SendMessage_Queue(UINT FuncId, BYTE *buffer, UINT Len)
{
	TCPDataStruct* Data = new TCPDataStruct();
	Data->funcId = FuncId;
	Data->data = new BYTE[Len];
	Data->dataLen = Len;
	if(Len > 0)
		memcpy(Data->data, buffer, Len);
	Data->CalcControlSum();
	Queue.Add(Data);

	Queue_Send();
}
//-----------------------------------------------------
void COperExpCDlg::SendMessage_(UINT FuncId, BYTE *buffer, UINT Len)
{
	if(!connected)
		return;
	TCPDataStruct* Data = new TCPDataStruct();
	Data->funcId = FuncId;
	Data->data = new BYTE[Len];
	Data->dataLen = Len;
	if(Len > 0)
		memcpy(Data->data, buffer, Len);
	Data->CalcControlSum();
	SendStruct(Data);
	delete Data;
}
//-----------------------------------------------------
/*void COperExpCDlg::SendBuffer_Queue(BYTE *Mes, UINT Len)
{
	BYTE *buffer = new BYTE[Len];
	memcpy(buffer, Mes, Len);

	Queue.AddMessage_Buffer((UINT)buffer, Len);

	Queue_Send();
}
*///-----------------------------------------------------
void COperExpCDlg::SendBuffer(BYTE *Mes, UINT Len)
{
	if(!connected)
		return;
	BYTE *buffer = new BYTE[Len];
	memcpy(buffer, Mes, Len);

    Send(SocketId, Mes, Len);
}
//-----------------------------------------------------
void COperExpCDlg::SendStruct_Queue(TCPDataStruct* Data)
{
	Queue.Add(Data);

	Queue_Send();
}
//---------------------------------------------------------------------------
void COperExpCDlg::SendStruct(TCPDataStruct* Data)
{
	if(!connected)
		return;
	int Len = _TCP_HEADER_SIZE_+Data->dataLen;
	BYTE *buffer = new BYTE[Len];
	memcpy(buffer,&(Data->funcId),sizeof(UINT));
	int offset = sizeof(UINT);
	memcpy(buffer+offset,&(Data->dataLen),sizeof(UINT));
	offset += sizeof(UINT);
	memcpy(buffer+offset,&(Data->controlSumm),sizeof(LONG));
	offset += sizeof(LONG);
	memcpy(buffer+offset, Data->data, Data->dataLen);
    Send(SocketId, buffer, Len);
    delete buffer;
}

//---------------------------------------------------------------------------
BOOL ProcessFunction(UINT SocketId, UINT Message)
{
DebugMessage("ProcessFunction");

	switch(Message)
	{
	case _ID_TCP_MESSAGE_DISCONNECTED_:
DebugMessage("_ID_TCP_MESSAGE_DISCONNECTED_");
		ExpDialog->connected = false;
		if(ExpDialog->complete)
			ExpDialog->m_Status.SetWindowText(" .   .");
		else
			ExpDialog->m_Status.SetWindowText(" .  .");
		ExpDialog->m_Progress.OffsetPos(100);
		if(ExpDialog->SocketId != -1)
		{
			if(DestroySocket(ExpDialog->SocketId))
			{
			    ExpDialog->SocketId = -1;
				//theApp.DoExit();
			}
		}
		ExpDialog->Stop();
        return TRUE;
	case _ID_TCP_MESSAGE_:
        {
DebugMessage("_ID_TCP_MESSAGE_");
			int ResLen;
			ResLen = GetReceiveLen(SocketId);
			if(ResLen > 0)
			{
				TCPDataStruct *Data = new TCPDataStruct();
				Data->data = new BYTE[ResLen];
				while(Receive_Struct(SocketId, Data))
				{
	                switch(Data->funcId)
		            {
					case _ID_COMMAND_EXPERIMENT_END_:
							ExpDialog->m_Status.SetWindowText(" ...");
							ExpDialog->SendMessage_(_ID_MESSAGE_CLOSE_REQUEST_, NULL, 0);
								ExpDialog->m_Progress.OffsetPos(99);
								ExpDialog->complete = true;
						break;
	                case _ID_DATA_GRAPH_:
						{
//char string[128];
								ExpDialog->m_Status.SetWindowText(" ...");
								UINT	Pos = (100 - ExpDialog->m_Progress.GetPos())/(measureChannels-Data->data[0]+1);
								ExpDialog->m_Progress.OffsetPos(Pos);
								//*******************************
								_LabGraphData newData;
								_DoubleArray *newArray = newData.AddDimR();
								int chNumber = (int)(Data->data[0]);
//sprintf(string,"Channel number = %d", chNumber);
//DebugMessage(string);
								int size;
								long elements;
								long offset=1;
								memcpy(&size, Data->data+offset, sizeof(int));
								offset+=sizeof(int);
//sprintf(string,"Size = %d", size);
//DebugMessage(string);
								memcpy(&elements, Data->data+offset, sizeof(long));
								offset+=sizeof(long);
//sprintf(string,"Elements number = %d", elements);
//DebugMessage(string);
								for(int i=0;i<elements;i++)
								{
									if(size == 4)
									{
										float newValue;
										memcpy(&newValue, Data->data+offset, size);
										newArray->Add((double)newValue);
//sprintf(string,"value[%d] = %f", i, newValue);
									}
									else
									if(size == 8)
									{
										double newValue;
										memcpy(&newValue, Data->data+offset, size);
										newArray->Add(newValue);
//sprintf(string,"value[%d] = %f", i, newValue);
									}
									offset+=size;
//DebugMessage(string);
								}
								char name[128];
								sprintf(name, "channel%d",(int)(Data->data[0]) );
								newData.SetName(name);
								
								if(GraphFunction != NULL)
								{
									GraphFunction(_ID_DATA_GRAPH_, (BYTE*)(&newData));
								}
								else
									if(m_hWndParent != NULL)
									{
										SendMessage(m_hWndParent,WM_USER+_ID_DATA_GRAPH_,(WPARAM)(&newData),0);
									}

/*								char filename[512];
								sprintf(filename, "operexp%d.tmp",(int)(Data->data[0]) );
								FILE *file = fopen(filename, "w");
								if(file != NULL)
								{
									fprintf(file, "Channel number = %d\n", (int)(Data->data[0]));
									long elements;
									long offset=1;
									int size;
									memcpy(&size, Data->data+offset, sizeof(int));
									offset+=sizeof(int);
									memcpy(&elements, Data->data+offset, sizeof(long));
									offset+=sizeof(long);
									fprintf(file, "Points number = %d\n\n", elements );
									for(int i=0;i<elements;i++)
									{
										float value;
										
										memcpy(&value, Data->data+offset, size);
										offset+=size;
										fprintf(file, "Element %2d = %8.3f\n", i,value );
									}
									fclose(file);
								}
*/								//*******************************
/*								if(GraphFunction != NULL)
								{
									GraphFunction(_ID_DATA_GRAPH_, Data->data);
								}
								else
									if(m_hWndParent != NULL)
									{
										SendMessage(m_hWndParent,WM_USER+_ID_DATA_GRAPH_,(WPARAM)(Data->data),0);
									}
*/
							ExpDialog->SendMessage_(_ID_MESSAGE_OK_, NULL, 0);
						}
			            break;
					case _ID_DATA_STATUS_STRING_:
						{
DebugMessage("_ID_DATA_STATUS_STRING_");
							int len = Data->dataLen;
							if(len > 0)
							{
								char *str = new char[len+1];
								memcpy(str, Data->data, len);
								str[len] = 0;
DebugMessage(str);
							if(strcmp(str, "Waiting") == 0)
							{
								ExpDialog->m_Status.SetWindowText("    ...");
								//ExpDialog->m_Progress.OffsetPos(Pos);
							}
							else
							if(strcmp(str, "ExperimentStart") == 0)
							{
								ExpDialog->m_Status.SetWindowText("  ...");
								//ExpDialog->m_Progress.OffsetPos(Pos);
							}
							else
							if(strcmp(str, "SwitchesON") == 0)
							{
								ExpDialog->m_Status.SetWindowText("  ...");
								//ExpDialog->m_Progress.OffsetPos(Pos);
							}
							else
							if(strcmp(str, "Sources") == 0)
							{
								ExpDialog->m_Status.SetWindowText("  ...");
								//ExpDialog->m_Progress.OffsetPos(Pos);
							}
							else
							if(strcmp(str, "ExpStart") == 0)
							{
								ExpDialog->m_Status.SetWindowText(" ...");
								//ExpDialog->m_Progress.OffsetPos(Pos);
							}
							else
							if(strcmp(str, "GraphIn") == 0)
							{
								ExpDialog->m_Status.SetWindowText("  ...");
								//ExpDialog->m_Progress.OffsetPos(Pos);
							}
							//else

								
								delete[] str;
							}
							ExpDialog->SendMessage_(_ID_MESSAGE_OK_, NULL, 0);
						}
						break;
				    case _ID_MESSAGE_STRING_:
						{
DebugMessage("_ID_MESSAGE_STRING_");
							ExpDialog->SendMessage_(_ID_MESSAGE_OK_, NULL, 0);
						}
						break;
					case _ID_MESSAGE_OK_:
						{
DebugMessage("_ID_MESSAGE_OK_");
							if(ExpDialog->complete && (ExpDialog->Queue.GetCount() == 0) )
							{
								/*ExpDialog->connected = false;
								DestroySocket(ExpDialog->SocketId);
								theApp.DoExit();*/
								ExpDialog->Stop();
							}
							ExpDialog->QueueCanSend();
						}
						break;
					case _ID_MESSAGE_ERROR_:
						{
							char str[128];
							sprintf(str, "_ID_MESSAGE_ERROR_ == %d", *((UINT*)(Data->data)));
DebugMessage(str);

							switch( *((UINT*)(Data->data)) )
							{
							case _ID_COMMAND_USER_MODULE_:
								{
									::MessageBox(NULL,"   -  . Code = 002.  .", "", MB_OK | MB_ICONERROR);

									ExpDialog->Stop();
									/*ExpDialog->connected = false;
									DestroySocket(ExpDialog->SocketId);
									theApp.DoExit();*/
								}
								break;
							}
						}
						break;
					}
				}
                delete Data;
            }
			if(ResLen > 0)
			{
			//	goto trytoread;
				//ProcessFunction(SocketId, _ID_TCP_MESSAGE_);
			}
        }
        return TRUE;
	}
	if(SocketId == _ID_TCP_ERROR_)
		{
			TCPErrorStruct *ErrorStruct = (TCPErrorStruct*)Message;
			switch(ErrorStruct->Code)
			{
			case 0:
            	return TRUE;
			case _ID_TCP_ERROR_WSAENETDOWN_:
			case _ID_TCP_ERROR_WSAECONNRESET_:
			case _ID_TCP_ERROR_WSAECONNABORTED_:
				{
					if(ExpDialog->SocketId != -1)
					{
						if(DestroySocket(ExpDialog->SocketId))
						{
						    ExpDialog->SocketId = -1;
							if(ExpDialog->complete)
								ExpDialog->m_Status.SetWindowText(" .   .");
							else
								ExpDialog->m_Status.SetWindowText(" .  .");
							ExpDialog->m_Progress.OffsetPos(100);
                            ExpDialog->connected = false;
							ExpDialog->Stop();
							//theApp.DoExit();
						}
					}
				}
            	return TRUE;
			}
		}
	return FALSE;
}

void COperExpCDlg::OnDblclkList1() 
{
//	m_Log.ResetContent();
	
}
