// OperExp02SWnd.cpp : implementation file
//

#include "stdafx.h"
#include "operexp02s.h"
#include "OperExp02SWnd.h"

#include "\cpp\labsignals.h"
#include "\cpp\labdata.h"
#include "\cpp\commands.h"
#include "\cpp\cwdaqconst.h"
#include "\cpp\cwsafearray_vc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


extern	char		moduleName[];
extern	HWND			MainWindow;

extern	COperExp02SWnd	*ExpWnd;
extern	char			ProFile[_MAX_PATH];

int		switches = 12;

/////////////////////////////////////////////////////////////////////////////
// COperExp02SWnd

COperExp02SWnd::COperExp02SWnd()
{
}

COperExp02SWnd::~COperExp02SWnd()
{
}


BEGIN_MESSAGE_MAP(COperExp02SWnd, CWnd)
	//{{AFX_MSG_MAP(COperExp02SWnd)
	ON_WM_CREATE()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// COperExp02SWnd message handlers

BOOL COperExp02SWnd::DestroyWindow() 
{
	if(Channels != NULL)
	{
		delete[] Channels;
		Channels = NULL;
	}
	
	return CWnd::DestroyWindow();
}

LRESULT COperExp02SWnd::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	switch(message)
	{
	case WM_USER+_ID_DATA_GRAPH_:
		{
//				Variant *data = (Variant*)wParam;

		
			float *fltData;
			double *dblData;
			CCWSafeArray	*vData = new CCWSafeArray( *((VARIANT*)wParam) );
			BYTE type = (BYTE)((VARIANT*)wParam)->vt;
			long channels;
			long dim;

			if(vData->GetNDims() == 1)
			{
				channels = 1;
				dim = vData->GetDimSize(1);
			}
			else
			{
				channels = vData->GetDimSize(1);
				dim = vData->GetDimSize(2);
			}



			int elementSize;
			if( type &VT_R4)
			{
				elementSize = 4;
				fltData = (float*)vData->AccessData();
			}
			else
				if( type & VT_R8)
				{
					elementSize = 8;
					dblData = (double*)vData->AccessData();
				}
				else
				{
					elementSize = 4;
					fltData = (float*)vData->AccessData();
				}

			BYTE *data;
			for(BYTE i=0;(int)i<channels;i++)
			{
				int Len = elementSize*dim+1+sizeof(long)+sizeof(int);
				
				data = new BYTE[Len];
				data[0] = i;
				int offset = 1;
				memcpy(data+1, &elementSize, sizeof(int));
				offset += sizeof(int);
				memcpy(data+offset, &dim, sizeof(long));
				offset += sizeof(long);
				if(elementSize == 4)
				{
					for(int j=0;j<dim;j++)
					{
						if(channels == 1)
						{
//							fltData[j] = -fltData[j];
							memcpy( data+offset+j*elementSize, &(fltData[j]), sizeof(float));
						}
						else
						{
//							fltData[i+j*channels] = -fltData[i+j*channels];
							memcpy( data+offset+j*elementSize, &(fltData[i+j*channels]), sizeof(float));
						}
					}
				}
				else
				if(elementSize == 8)
				{
					for(int j=0;j<dim;j++)
					{
						if(channels == 1)
						{
//							dblData[j] = -dblData[j];
							memcpy( data+offset+j*elementSize, &(dblData[j]), sizeof(double));
						}
						else
						{
//							dblData[i+j*channels] = -dblData[i+j*channels];
							memcpy(data+offset+j*elementSize, &(dblData[i+j*channels]), sizeof(double));
						}
					}
				}
				::SendMessage(MainWindow, _ID_DATA_GRAPH_, (WPARAM)data, Len);
			}

			vData->UnaccessData();
		
		
		
		
		}
		return 0;
	case _ID_COMMAND_EXPERIMENT_START_:
		{
			if(wParam != NULL)
			{
				BYTE *buffer = (BYTE*)wParam;
				UINT len;
				memcpy(&len, buffer, sizeof(UINT));
				if(len <=sizeof(UINT))
					return 0;
				int offset = sizeof(UINT);

				if(len < (UINT)(switches+offset))
					return 0;

				//***********		Switches
				memcpy(Switches, buffer+offset, switches);
				offset+=switches;

				//***********		Measure params
				memcpy(&(Measure.mChNum), buffer+offset, sizeof(UINT));
				offset+=sizeof(UINT);
				Measure.mChs = new BYTE[Measure.mChNum];
				memcpy(Measure.mChs, buffer+offset, sizeof(BYTE)*Measure.mChNum);
				offset+=sizeof(BYTE)*Measure.mChNum;
				memcpy(&(Measure.PointsNum), buffer+offset, sizeof(UINT));
				offset+=sizeof(UINT);
				memcpy(&(Measure.PointsPerSec), buffer+offset, sizeof(UINT));
				offset+=sizeof(UINT);


				//***********		Sources
			for(int i=0;i<2;i++)
			{
				SOURCE *Source = new SOURCE();
				Source->Type = buffer[offset];
				offset++;
				switch(Source->Type)
				{
				case _SIGNALS_TYPE_NONE_:
					break;
				case _SIGNALS_TYPE_PULSE_:
					{
						Signal_Pulse *Signal =  new Signal_Pulse();
						memcpy(&(Signal->T0), buffer+offset, sizeof(double));
						offset += sizeof(double);
						memcpy(&(Signal->Y0), buffer+offset, sizeof(double));
						offset += sizeof(double);
						Source->Recycle = buffer[offset];
						offset += 1;
						Source->data = (UINT)Signal;
					}
					break;
				case _SIGNALS_TYPE_SQUARE_:
					{
						Signal_Square	*Signal = new Signal_Square();
						memcpy(&(Signal->T), buffer+offset, sizeof(double));
						offset += sizeof(double);
						memcpy(&(Signal->T0), buffer+offset, sizeof(double));
						offset += sizeof(double);
						memcpy(&(Signal->Y0), buffer+offset, sizeof(double));
						offset += sizeof(double);
						memcpy(&(Signal->T1), buffer+offset, sizeof(double));
						offset += sizeof(double);
						Source->Recycle = buffer[offset];
						offset += 1;
						Source->data = (UINT)Signal;
					}
					break;
				case _SIGNALS_TYPE_POLINOM_:
					{
						Signal_Polinom	*Signal = new Signal_Polinom();
						memcpy(&(Signal->T), buffer+offset, sizeof(double));
						offset += sizeof(double);
						memcpy(&(Signal->N), buffer+offset, sizeof(int));
						offset += sizeof(int);

						Signal->Tn = new double[Signal->N];
						Signal->Yn = new double[Signal->N];
						for(int j=0;j<Signal->N;j++)
						{
							memcpy(&(Signal->Tn[j]), buffer+offset, sizeof(double));
							offset += sizeof(double);
							memcpy(&(Signal->Yn[j]), buffer+offset, sizeof(double));
							offset += sizeof(double);
						}

						Source->Recycle = buffer[offset];
						Source->data = (UINT)Signal;

						offset += 1;
					}
					break;
				case _SIGNALS_TYPE_SIN_:
					{
						Signal_Sine	*Signal = new Signal_Sine();
						memcpy(&(Signal->F), buffer+offset, sizeof(double));
						offset += sizeof(double);
						memcpy(&(Signal->Y), buffer+offset, sizeof(double));
						offset += sizeof(double);
						memcpy(&(Signal->Fi), buffer+offset, sizeof(double));
						offset += sizeof(double);
						Source->Recycle = buffer[offset];
						Source->data = (UINT)Signal;
						offset += 1;
					}
					break;
				}
				Sources.Add(Source);
			}




				::SendMessage(MainWindow, _ID_RS485_COMMAND_+_ID_COMMAND_OPEN_DEVICE_, (WPARAM)devAddress, 0);
				SetSwitches(Switches);
			}
		}
		return 0;
	case _ID_SYSTEM_UNINITIALIZE_:
		{
			::SendMessage(MainWindow, _ID_RS485_COMMAND_+_ID_COMMAND_CLOSE_DEVICE_, (WPARAM)devAddress, 0);

			if(NIDAQDLL != NULL)
			{
				if(NIDAQFunction != NULL)
				{
    				NIDAQFunction(_ID_SYSTEM_UNINITIALIZE_,0);
				}
            	FreeLibrary(NIDAQDLL);
                NIDAQDLL = NULL;
			}
		}
		return 0;
	case _ID_RS485_MESSAGE_:
		switch(wParam)
		{
		case _ID_RS485_MESSAGE_:
			{
				CRS485Message *mes = (CRS485Message*)wParam;
				int	ID = (int)mes->GetID();
				switch(ID)
				{
				case cmOK:
					StartExperiment();
					break;
				default:
					timeouts++;
					if(timeouts > 3)
					{
						::SendMessage(MainWindow, _ID_COMMAND_SEND_ERROR_, _ID_RS485_COMMAND_+ID, 0);
					}
					else
					{
						::SendMessage(MainWindow, _ID_RS485_COMMAND_+_ID_COMMAND_SEND_DATA_RETRIEVE_, (WPARAM)devAddress, 0);
					}
					break;
				}
			}
			break;
		case errTIMEOUT:
			timeouts++;
			if(timeouts > 3)
			{
				::SendMessage(MainWindow, _ID_COMMAND_SEND_ERROR_, _ID_RS485_COMMAND_+errTIMEOUT, 0);
			}
			else
			{
				::SendMessage(MainWindow, _ID_RS485_COMMAND_+_ID_COMMAND_SEND_DATA_RETRIEVE_, (WPARAM)devAddress, 0);
			}
			break;
		}
		return 0;
	}
	
	return CWnd::WindowProc(message, wParam, lParam);
}

int COperExp02SWnd::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	NIDAQDLL=NULL;
	NIDAQFunction=NULL;

	devAddress = GetPrivateProfileInt("SYSTEM", moduleName, 229, ProFile);
	NChannels = GetPrivateProfileInt("MEASURE", "Channels", 1, ProFile);
	Channels = new int[NChannels];
	char string[5];
	for(int i=0;i<NChannels;i++)
	{
		sprintf(string, "ch%d", i);
		Channels[i] = GetPrivateProfileInt("MEASURE", string, i, ProFile);
	}


		return 0;
}

void COperExp02SWnd::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	
	CWnd::OnTimer(nIDEvent);
}

void COperExp02SWnd::StartExperiment()
{
	_LabGraphDataArray Inputs;

			AIPar.AllocationMode = cwaiHostMemory;
			char ChannelString[255];
			char	str1[5];
			sprintf(ChannelString, "");
			for(UINT i=0;i<Measure.mChNum;i++)
			{
				if(i>0)
				{
					sprintf(str1, ",%d", (int)(Channels[Measure.mChs[i]]) );
					strcat(ChannelString, str1);
				}
				else
				{
					sprintf(ChannelString, "%d", (int)(Channels[Measure.mChs[i]]) );
				}
			}
            AIPar.ChannelString = ChannelString;
			AIPar.Coupling = cwaiDC;
			AIPar.InputMode = cwaiRSE;
			AIPar.LowerLimit = -5.;
			AIPar.NScans = Measure.PointsNum;
			AIPar.ReturnDataType = cwaiVoltages;
			AIPar.UpperLimit = 5.;
			AIPar.ScanClock = Measure.PointsPerSec;

	AOPar.Infinite = TRUE;
	AOPar.AllocationMode = cwaoOnBoardFIFO;
	AOPar.AllowRegeneration = TRUE;
	AOPar.NUpdates = AIPar.NScans;
	AOPar.ClockSourceType = cwaoInternalCS;
	AOPar.ChannelType = cwaoVoltage;
	AOPar.ChannelString = "0,1";
	AOPar.UpperLimit = 10;
	AOPar.LowerLimit = -10;
	AOPar.NIterations = 1;
	AOPar.StartCondition = cwaoAIStartTrigger;//;

	double	T = (double)(AIPar.NScans)/(double)(AIPar.ScanClock);
	if(T<0.0005)
		T = 0.0005;
	UINT	Points = 1024;
	if(T < 0.002)
		Points/=2;
	if(T < 0.001)
		Points/=2;
	AOPar.ClockFrequency = ((float)Points)/(float)T;;//AIparams->PointsPerSec;//Parameters->NUpdates;
	if(AOPar.ClockFrequency > 500000.)
	{
		AOPar.ClockFrequency = 500000.;
		AOPar.NUpdates = (LONG)((double)(AOPar.ClockFrequency)*T);
	}
	AOPar.RefType = cwaoInternal;



	for(i=0;i<Sources.GetCount();i++)
	{
		SOURCE *Source = Sources.Item(i);
		switch(Source->Type)
		{
		case _SIGNALS_TYPE_NONE_:
			{
				_LabGraphData *newData = Inputs.Add();
				_DoubleArray *newY = newData->AddDimR();
				for(UINT j=0;j<Points;j++)
				{
					newY->Add(0.0);
				}
			}
			break;
		case _SIGNALS_TYPE_PULSE_:
		case _SIGNALS_TYPE_SQUARE_:
		case _SIGNALS_TYPE_SIN_:
		case _SIGNALS_TYPE_POLINOM_:
			{
					_LabData *newData = new _LabData();
					double	*x = new double[Points];
					double	*y = new double[Points];
					GenerateSignal(Source->Type, (void*)(Source->data),x,y,
								Points,
								T,
								Source->Recycle);

					newData->AddDim(new _DoubleArray(y,Points));

					Inputs.Add(new _LabGraphData(newData));
					delete newData;
					delete x;
					delete y;
			}
		}
	}

	UINT sources = Inputs.GetCount();
	if(sources == 0)
		return;

	UINT Count = Inputs.Item(0)->Dim(0)->GetSize();
	CCWSafeArray	vData(VT_R8, Count*sources);
	double		*yData = (double*)vData.AccessData();

	for(i=0;i<Count;i++)
	{
		for(UINT j=0;j<sources;j++)
		{
			UINT index = i*sources+j;
			yData[index] = Inputs.Item(j)->Dim(0)->Item(i);
		}
	}
	vData.UnaccessData();



    	NIDAQDLL = (HINSTANCE)LoadLibrary("plnidaq.dll");
        if(NIDAQDLL != NULL)
        {
        	NIDAQFunction = (FUNCTION1)GetProcAddress(NIDAQDLL, "_plnidaq");
            if(NIDAQFunction == NULL)
            {
            	FreeLibrary(NIDAQDLL);
                NIDAQDLL = NULL;
            }
            else
            {
            	NIDAQFunction(_ID_SYSTEM_MAIN_WINDOW_, (UINT)m_hWnd);
            	NIDAQFunction(_ID_SYSTEM_INITIALIZE_,0);

				NIDAQFunction(_ID_SYSTEM_AO_SET_PARAMETERS_, (UINT)&AOPar);
				NIDAQFunction(_ID_SYSTEM_AI_SET_PARAMETERS_, (UINT)&AIPar);
		
				NIDAQFunction(_ID_SYSTEM_AO_SET_WAVEFORM_, (UINT)&vData);

		        NIDAQFunction(_ID_SYSTEM_AO_START_, 0);
		        NIDAQFunction(_ID_SYSTEM_AI_START_, 0);
            }
        }


}


//*************************************************************
void COperExp02SWnd::SetSwitches(BYTE *values)
{
	CRS485Message newData;	
	int dataLen = 6;
			newData.SetID(cmSET);	//*****************
			BYTE *data = new BYTE[6];
			BYTE	low,high;

			if(values[0] == 0xFF)	//	R1
				low = 0;
			else
				low = values[0] + 8;
			if(values[1] == 0xFF)	//	R2
				high = 0;
			else
				high = values[1] + 8;
			high = (high&0x0F)<<4;
			data[0] = low + high;

			if(values[9] == 1)	//	C1 & sw1
				low = 8;
			else
				if(values[6] == 0xFF)
					low = 0;
				else
					low	= values[6] + 8;
			if(values[11] == 1 || values[11] == 2)
				high = values[11]+7;
			else 
				high = 0; //	sw2
	
			high = (high&0x0F)<<4;
			data[1] = low + high;

			if(values[2] == 0xFF)	//	R3
				low = 0;
			else
				low = values[2] + 8;
			if(values[3] == 0xFF)	//	R4
				high = 0;
			else
				high = values[3]+8;
			high = (high&0x0F)<<4;
			data[2] = low + high;

			if(values[7] == 0xFF)	//	C2
				low = 0;
			else
				low = values[7] + 8;
			data[3] = low;

			if(values[4] == 0xFF)	//	R5
				low = 0;
			else
				low = values[4] + 8;
			if(values[5] == 0xFF)	//	R6
				high = 0;
			else
				high = values[5]+8;
			high = (high&0x0F)<<4;
			data[4] = low + high;

			if(values[10] == 1)		// vd & C3
				low = 8;
			else
				if(values[8] == 0xFF)
					low = 0;
				else
					low = values[8] + 8;
			data[5] = low;

	newData.SetAddress(devAddress);
	newData.SetData(dataLen, data);

	::SendMessage(MainWindow, _ID_RS485_COMMAND_+_ID_COMMAND_SEND_DATA_, (WPARAM)&newData, 0);
	timeouts = 0;
}
