// RS485Form.cpp : implementation file
//

#include "stdafx.h"
#include "rs485.h"
#include "RS485Form.h"
#include "\cpp\utils.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


extern int _BYTES_TO_LEN_;

extern HWND MainWindow;

extern bool	SendDebugInfo;

/////////////////////////////////////////////////////////////////////////////
// CRS485Form dialog


CRS485Form::CRS485Form(CWnd* pParent /*=NULL*/)
	: CDialog(CRS485Form::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRS485Form)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CRS485Form::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRS485Form)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CRS485Form, CDialog)
	//{{AFX_MSG_MAP(CRS485Form)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
		ON_WM_SERIAL(OnSerialMsg)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRS485Form message handlers

LRESULT CRS485Form::OnSerialMsg (WPARAM wParam, LPARAM lParam)
{
   	if(MainWindow != NULL && SendDebugInfo)
    {
	char string[128];
    	sprintf(string, "OnSerialMsg");
		::SendMessage(MainWindow, _ID_RS485_LOGGING_MESSAGE_, (WPARAM)string, (LPARAM)strlen(string));
    }
	CSerial::EEvent eEvent = CSerial::EEvent(LOWORD(wParam));
	CSerial::EError eError = CSerial::EError(HIWORD(wParam));

	if (eError)
//		DisplayEvent(_T("An internal error occurred."));
	{
	}

	if (eEvent & CSerial::EEventBreak)
//		DisplayEvent(_T("Break detected on input."));
	{
	}

	if (eEvent & CSerial::EEventError)
//		DisplayEvent(_T("A line-status error occurred."));
	{
		Comm1->Close();
		OpenPort();
					char string[128];
   					if(MainWindow != NULL && SendDebugInfo)
					{
    					sprintf(string, "A line-status error occurred.");
						::SendMessage(MainWindow, _ID_RS485_LOGGING_MESSAGE_, (WPARAM)string, (LPARAM)strlen(string));
					}
	}
	
	if (eEvent & CSerial::EEventRcvEv)
//		DisplayEvent(_T("Event character has been received."));
	{
	}

	if (eEvent & CSerial::EEventRing)
//		DisplayEvent(_T("Ring detected"));
	{
	}
	
	if (eEvent & CSerial::EEventSend)
//		DisplayEvent(_T("All data is send"));
	{
   	if(MainWindow != NULL && SendDebugInfo)
    {
	char string[128];
    	sprintf(string, "Comm1TxEmpty");
		::SendMessage(MainWindow, _ID_RS485_LOGGING_MESSAGE_, (WPARAM)string, (LPARAM)strlen(string));
    }
		SetTimer(3,2,NULL);
	}
	
	if (eEvent & CSerial::EEventCTS)
//		DisplayEventSetting(_T("CTS signal change"), _T("CTS"), m_serial.GetCTS());
	{
	}
	
	if (eEvent & CSerial::EEventDSR)
//		DisplayEventSetting(_T("DSR signal change"), _T("DSR"), m_serial.GetDSR());
	{
	}
	
	if (eEvent & CSerial::EEventRLSD)
//		DisplayEventSetting(_T("RLSD signal change"), _T("RLSD"), m_serial.GetRLSD());
	{
	}
	
	if (eEvent & CSerial::EEventRecv)
	{
   	if(MainWindow != NULL && SendDebugInfo)
    {
	char string[128];
    	sprintf(string, "Comm1TxEmpty");
		::SendMessage(MainWindow, _ID_RS485_LOGGING_MESSAGE_, (WPARAM)string, (LPARAM)strlen(string));
    }
        BYTE    *buffer;
		DWORD dwRead;
        buffer = new BYTE[1000];
        Comm1->Read(buffer,999,&dwRead);//*************************************
        if(canRead)
        {
            RSBuffer.Write(buffer,dwRead);
            ProcessRSMessages();
        }
        delete[] buffer;
/*		// Create a clean buffer
		DWORD dwRead;
		char szData[101];
		const int nBuflen = sizeof(szData)-1;

		// Obtain the data from the serial port
		do
		{
			m_serial.Read(szData,nBuflen,&dwRead);
			szData[dwRead] = '\0';

			// Scan the string for unwanted characters
			for (DWORD dwChar=0; dwChar<dwRead; dwChar++)
			{
				if (!isprint(szData[dwChar]) && !isspace(szData[dwChar]))
				{
					szData[dwChar] = '.';
				}
			}

			// Display the fetched string
			DisplayData(szData);
		} while (dwRead == nBuflen);
*/
	}

	return 0;
}
bool CRS485Form::OpenPort()
{
	if (Comm1->Open(_T(PortName),this) != ERROR_SUCCESS)
/*
	LONG result;
	if(PortName == "COM1")
		result = Comm1->Open(_T("COM1"),this);
	else
	if(PortName == "COM2")
		result = Comm1->Open(_T("COM2"),this);
	else
	{
		char string[128];
		sprintf(string, "Unknown port. PortName = %s", PortName.GetAt(0));
		::MessageBox(NULL, string, "Error", MB_OK);
		return false;
	}
	if (result != ERROR_SUCCESS)
*/	{
		return false;
	}
    Comm1->Setup(CSerial::EBaud19200,CSerial::EData8,CSerial::EParNone,CSerial::EStop2);//******************
    Comm1->SetupHandshaking(CSerial::EHandshakeOff);
//	SetCommMask(Comm1->GetCommHandle(), 0xFF);//EV_RXCHAR | EV_TXEMPTY); 
	Comm1->SetMask(CSerial::EEventRecv|CSerial::EEventSend/*|CSerial::EEventError*/);

	return true;
}

//---------------------------------------------------------------------------
bool CRS485Form::OpenDevice(BYTE address)
{
    if( Devices.FindIndex(address) != -1)
        return false;
    CRS485Device *newDevice = new CRS485Device();
    newDevice->Address = address;
    Devices.Add(newDevice);

    
    return true;
}

LRESULT CRS485Form::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	switch(message)
	{
	case WM_TIMER:
		{
			switch(wParam)
			{
			case 1:	//	device timer
				ProcessDevices();
				return 0;
			case 2:	//	timeout timer
				{
					for(int i=0;i<Devices.GetCount();i++)
					{
						CRS485Device *device = Devices.Item(i);
						if(device->Timer)
						{
							device->TimerTick += 1;
							if(device->TimerTick > _RS485_TIMEOUT_)
    						{
        						device->errStatus = errTIMEOUT;
								RTS = true;
							}
						}
					}
				}
				return 0;
			case 3:	//	dtr timer
				{
					EscapeCommFunction(Comm1->GetCommHandle(), SETDTR);
					EscapeCommFunction(Comm1->GetCommHandle(), CLRDTR);

					KillTimer(3);
					canRead = true;
				}
				return 0;
			case 5:
				readTimeout = true;
				RSBuffer.Delete(RSBuffer.GetCount());
				readTimeoutStarted = false;
				KillTimer(5);
				return 0;
			}
		}
		break;
	}
	
	return CDialog::WindowProc(message, wParam, lParam);
}
//---------------------------------------------------------------------------
bool	__fastcall  CRS485Form::Send(BYTE Address)
{
	CRS485Device *device = Devices.Find(Address);
    if(device != NULL)
    {
        return Send(device);
    }
    else
    	return false;
}
//---------------------------------------------------------------------------
bool	__fastcall  CRS485Form::Send(CRS485Device *Device)
{
	Device->TimerTick = 0;
    if(Device->OutQueue.GetCount() > 0)
    {
	    Device->errStatus = _ID_RS485_MESSAGE_WAITING_;
    }
    return true;
}
//---------------------------------------------------------------------------
bool	__fastcall  CRS485Form::SendNext(BYTE Address)
{
	CRS485Device *device = Devices.Find(Address);
    if(device != NULL)
    {
		CRS485Message *mes = (CRS485Message*)(device->OutQueue.Pop());
		if(mes != NULL)
		{
	   		delete mes;
		}
        return Send(device);
    }
    else
    	return false;
}
//---------------------------------------------------------------------------
bool	__fastcall  CRS485Form::Send(CRS485Message *message)
{
	BYTE Address = message->GetAddress();
	CRS485Device *device = Devices.Find(Address);
    if(device != NULL)
    {
        return Send(device,message);
    }
    else
    	return false;
}
//---------------------------------------------------------------------------
UINT	__fastcall  CRS485Form::SendWait(CRS485Message *message)
{
	BYTE Address = message->GetAddress();
	CRS485Device *device = Devices.Find(Address);
    if(device != NULL)
    {
        if(Send(device,message))
        {
        	while(device->errStatus == _ID_RS485_MESSAGE_WAITING_)
            {
				MSG msg;
				::PeekMessage(&msg, NULL, 0, 0, PM_REMOVE);
				::DispatchMessage(&msg);
				::TranslateMessage(&msg);
            }
            return device->errStatus;
        }
        else
        	return -1;
    }
    else
    	return -1;
}
//---------------------------------------------------------------------------
bool	__fastcall  CRS485Form::Send(CRS485Device *Device, CRS485Message *message)
{
	Device->OutQueue.Push(message);
    return Send(Device);
}
//---------------------------------------------------------------------------
void    __fastcall CRS485Form::Send(BYTE address, BYTE command, BYTE *buffer, UINT Len)
{
    BYTE    header;
    BYTE *sBuffer;
    if(_BYTES_TO_LEN_ == 1)
    {
        header = 8;
        sBuffer = new BYTE[8+Len];
        sBuffer[0] = sBuffer[1] = sBuffer[2] = sBuffer[3] = sBuffer[4] = 0x40;
        sBuffer[5] = address;
        sBuffer[6] = Len+1;
        sBuffer[7] = command;
    }
    else
    if(_BYTES_TO_LEN_ == 2)
    {
        header = 9;
        sBuffer = new BYTE[9+Len];
        sBuffer[0] = sBuffer[1] = sBuffer[2] = sBuffer[3] = sBuffer[4] = 0x40;
        sBuffer[5] = address;
        DWORD	len = (DWORD)Len+1;
        sBuffer[6] = (BYTE)(len&0xFF);
//		len = len>>8;
//		len = len&0x00FF;
        sBuffer[7] = (BYTE)((len&0xFF00)>>8);
        sBuffer[8] = command;
    }
    if(Len > 0)
    {
        memcpy(sBuffer+header,buffer,Len);
    }
    canRead = false;
    RTS = false;
            Comm1->Purge();
    char string[128];
   	if(MainWindow != NULL && SendDebugInfo)
    {
    	sprintf(string, "SetDTRState(false)");
		::SendMessage(MainWindow, _ID_RS485_LOGGING_MESSAGE_, (WPARAM)string, (LPARAM)strlen(string));
    }
	EscapeCommFunction(Comm1->GetCommHandle(), CLRDTR);

   	if(MainWindow != NULL && SendDebugInfo)
    {
    	sprintf(string, "SetRTSState(true)");
		::SendMessage(MainWindow, _ID_RS485_LOGGING_MESSAGE_, (WPARAM)string, (LPARAM)strlen(string));
    }
	EscapeCommFunction(Comm1->GetCommHandle(), SETRTS);

   	if(MainWindow != NULL && SendDebugInfo)
    {
    	sprintf(string, "SetRTSState(false)");
		::SendMessage(MainWindow, _ID_RS485_LOGGING_MESSAGE_, (WPARAM)string, (LPARAM)strlen(string));
    }
	EscapeCommFunction(Comm1->GetCommHandle(), CLRRTS);

	DWORD written=0;


	if(SendDebugInfo)
	{
		::SendMessage(MainWindow, _ID_RS485_BUFFER_, (WPARAM)sBuffer, (LPARAM)(Len+header));
		{
			char str1[4],string[128];
			CString aBuffer="";
			UINT Count = Len+header;
			for(UINT i=0;i<Count;i++)
			{
				int len = sprintf(str1, "%x ", sBuffer[i]);
				if(len == 2)
				{
					str1[3] = 0;
					str1[2] = str1[1];
					str1[1] = str1[0];
					str1[0] = '0';
				}
				aBuffer += CString(str1);
			}
			FILE *file = fopen("rs485.txt", "a+");
			fprintf(file, "BufferOut = '%s'\n", aBuffer.GetBuffer(0));
			fclose(file);
		}
	}

    Comm1->Write(sBuffer,Len+header,&written,0,100);
    delete     sBuffer;
}
//---------------------------------------------------------------------------
void    __fastcall  CRS485Form::ProcessDevices()
{
    for(int i=0;i<Devices.GetCount();i++)
    {
        CRS485Device *device = Devices.Item(i);
        switch(device->errStatus)
        {
        case _ID_RS485_MESSAGE_WAITING_:
        	{
            	if(device->OutQueue.GetCount() > 0)
                {
	            	if(RTS)
    	            {
                    	CRS485Message *mes = (CRS485Message*)(device->OutQueue.Peek());
                        UINT Len = mes->GetLen();
                        UINT Len2 = Len+2;
                        DWORD summ = mes->CalcChSum();
                        BYTE *buffer = new BYTE[Len2];
						if(Len > 0)
						{
							memcpy(buffer, mes->GetData(), Len);
						}
                        buffer[Len] = *((BYTE*)(&summ));
                        buffer[Len+1] = *(((BYTE*)(&summ))+1);
                        Send(mes->GetAddress(), mes->GetID(), buffer, Len2);
                        device->Timer = true;
                        delete[] buffer;
                    }
                }
            }
        	break;
        case _ID_RS485_MESSAGE_:
        	{
            	if(device->InQueue.GetCount() > 0)
                {
	            	CRS485Message *mes = (CRS485Message*)(device->InQueue.Pop());
                    WORD ID = mes->GetID();
                    switch(ID)
                    {
                    case cmOK:
                    	{
                        	if(device->OutQueue.GetCount() > 0)
                            {
                                SendNext(device->Address);
                            }
                        	if(device->OutQueue.GetCount() == 0)
                            {
                            	if(MainWindow != NULL)
                                {
									::SendMessage(MainWindow, _ID_RS485_MESSAGE_, _ID_RS485_MESSAGE_, (LPARAM)mes);
                                }
                            }
                        }
                    	break;
                    default:
                    	{
                            	if(MainWindow != NULL)
                                {
									::SendMessage(MainWindow, _ID_RS485_MESSAGE_, _ID_RS485_MESSAGE_, (LPARAM)mes);
                                }
                        }
                        break;
                    }
                    if(mes != NULL)
					{

                    	delete mes;

					}
                }
            }
        	break;
        case errTIMEOUT:
          	if(MainWindow != NULL)
            {
               	::PostMessage(MainWindow, _ID_RS485_MESSAGE_, errTIMEOUT, (LPARAM)(device->Address));
                device->errStatus = cmOK;
                device->Timer = false;
            }
        	break;
        }
    }
}

void    __fastcall CRS485Form::DebugBufferToFile(BYTE *buffer, UINT Count)
{
		if(SendDebugInfo)
		{
			char *string=NULL;
			BufToString(buffer, Count, string);
			FILE *file = fopen("rs485.txt", "a+");
			fprintf(file, "Count  = '%d'\n", Count);
			fprintf(file, "BufferIn  = '%s'\n", string);
			fclose(file);
			if(string != NULL)
				delete[] string;
		}
}
void    __fastcall CRS485Form::DebugStrToFile(LPSTR mes)
{
		if(SendDebugInfo)
		{
			FILE *file = fopen("rs485.txt", "a+");
			fprintf(file, "%s\n", mes);
			fclose(file);
		}
}
//---------------------------------------------------------------------------
void    __fastcall CRS485Form::ProcessRSMessages()
{
    UINT Count = RSBuffer.GetCount();
	if(Count > 0 && !readTimeoutStarted)
	{
		readTimeoutStarted = true;
		readTimeout = false;
		SetTimer(5, 1000,NULL);
	}
    while(Count > 0 && !readTimeout)
    {
        int offset=0;

		if(SendDebugInfo)
		{
            BYTE *buffer = new BYTE[Count];
            RSBuffer.Peek(buffer,Count);
            ::SendMessage(MainWindow, _ID_RS485_BUFFER_, (WPARAM)buffer, (LPARAM)Count);
			delete[] buffer;
		}

        if(Count >= 5)
        {
            BYTE *buffer = new BYTE[5];
            RSBuffer.Peek(buffer,5);
            if( !(buffer[0] == 0x40 &&
            		buffer[1] == 0x40 &&
                    buffer[2] == 0x40 &&
                    buffer[3] == 0x40 &&
                    buffer[4] == 0x40) )
            {
	            RSBuffer.DeleteHead();
            }
            delete[] buffer;
        }

		if(SendDebugInfo)
		{
            BYTE *buffer = new BYTE[Count];
            RSBuffer.Peek(buffer,Count);
            ::SendMessage(MainWindow, _ID_RS485_BUFFER_, (WPARAM)buffer, (LPARAM)Count);

			char *string=NULL;
			BufToString(buffer, Count, string);

			::SendMessage(MainWindow, _ID_RS485_LOGGING_MESSAGE_, (WPARAM)string, (LPARAM)strlen(string));
			delete[] buffer;
			if(string != NULL)
				delete[] string;
		}

        //	@@@@@ALLI__SS - _BYTES_TO_LEN_==2
        //	@@@@@ALI__SS - _BYTES_TO_LEN_==1
		if(Count >= (UINT)(6+_BYTES_TO_LEN_))
		{
            BYTE *buffer = new BYTE[Count];
            RSBuffer.Peek(buffer,Count);
DebugBufferToFile(buffer, Count);

			if( buffer[0] == 0x40 &&
            		buffer[1] == 0x40 &&
                    buffer[2] == 0x40 &&
                    buffer[3] == 0x40 &&
                    buffer[4] == 0x40 )
            {
				offset = 5;
                BYTE address = buffer[offset];
                offset+=1;

                UINT mesLen;
				UINT	header;
                if(_BYTES_TO_LEN_ == 2)
                {
                 	mesLen = (UINT)(buffer[offset+1]);
                    mesLen = mesLen << 8;
                    mesLen += (UINT)(buffer[offset]);
                    offset+=2;
					header = 8;
                }
                else
                if(_BYTES_TO_LEN_ == 1)
                {
                 	mesLen = (UINT)(buffer[offset]);
                    offset+=1;
					header = 7;
                }
				else
				{
					break;
				}

		if(SendDebugInfo)
		{
			char string[128];
    		sprintf(string, "mesLen == %d, header == %d", mesLen, header);
			::SendMessage(MainWindow, _ID_RS485_LOGGING_MESSAGE_, (WPARAM)string, (LPARAM)strlen(string));
		}		


				UINT Len = mesLen + header;
				if(Len > Count)
				{
DebugStrToFile("Len > Count");
//					goto wait_more_bytes;
					delete[] buffer;
					return;
				}

				RSBuffer.Read(buffer,Len);
                

				CRS485Message *newMessage = new CRS485Message();
                newMessage->SetAddress((BYTE)address);
                newMessage->SetID(buffer[offset]);
				offset+=1;
				UINT dataLen = Len-offset;
		if(SendDebugInfo)
		{
			char string[128];
    		sprintf(string, "Len == %d, dataLen == %d, offset == %d", Len, dataLen, offset);
			::SendMessage(MainWindow, _ID_RS485_LOGGING_MESSAGE_, (WPARAM)string, (LPARAM)strlen(string));
		}		

				DWORD mesSum;
				DWORD chSum;
				if( dataLen >= 2)
				{
					mesSum = (WORD)(buffer[Len-1]);
					mesSum = mesSum << 8;
   					mesSum += (WORD)(buffer[Len-2]);
				}
				if( dataLen == 2)
				{
					newMessage->SetData(0, NULL);
				}
				else
				if( dataLen > 2)
				{
//					dataLen-=2;
					newMessage->SetData(dataLen-2, buffer+offset);
				}
				
				chSum = newMessage->CalcChSum();
				if(mesSum != chSum)
				{
               		newMessage->BadCRC = 1;
				}

				
                CRS485Device *device = Devices.Find((BYTE)address);
                if(device != NULL)
                {
                    	device->InQueue.Push(newMessage);
                        device->Timer = false;
                        device->errStatus = _ID_RS485_MESSAGE_;
                }
                else
                {
                  	delete newMessage;
                }

                //**********
                RTS = true;

			}
//wait_more_bytes:
			delete[] buffer;
		}

        if( RSBuffer.PeekByte() != '@') // 0x40
        {
            RSBuffer.DeleteHead();
        }

		MSG msg;
		::PeekMessage(&msg, NULL, 0, 0, PM_REMOVE);
		::DispatchMessage(&msg);
		::TranslateMessage(&msg);

        Count = RSBuffer.GetCount();
		if(readTimeout)
		{
			RSBuffer.Delete(Count);
		}
    }
	if(readTimeoutStarted)
	{
		readTimeoutStarted = false;
		KillTimer(5);
	}
}
//---------------------------------------------------------------------------

int CRS485Form::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	Comm1 = new CSerialMFC();
	PortName = "COM1";
	Port = 1;

	RTS = true;

	SetTimer(1,100,NULL);
	SetTimer(2,1000,NULL);
	
	return 0;
}

void CRS485Form::OnDestroy() 
{
	CDialog::OnDestroy();
	
	KillTimer(1);
	KillTimer(2);
	if(readTimeoutStarted)
	{
		readTimeoutStarted = false;
		KillTimer(5);
	}

	for(UINT i=0;i<Devices.GetCount();i++)
	{
		delete Devices.Item(i);
	}

	Comm1->Close();
	delete Comm1;
	Comm1 = NULL;
	
}
