#if !defined(_COMM485_H_FILE_INCLUDED_)
#define _COMM485_H_FILE_INCLUDED_

#include "\cpp\51defs.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define     _RS485_TIMEOUT_ 5      //  in sec
#define     _RS485_WAITING_ 0xFF


//extern "C" __declspec(dllimport) UINT Comm485(UINT command, UINT Param);

//*******	TYPES	******************
#ifndef _FUNCTION1_defined_
#define _FUNCTION1_defined_
typedef UINT (*FUNCTION1)(UINT Command, UINT Parameters);
#endif

typedef UINT (*COMM485MAINPROC )(UINT command, UINT Param);

//---------------------------------------------------------------------------
class CRS485Message
{
private:
    BYTE    Address;
    BYTE    FuncID;
    WORD    Len;
    BYTE   *Data;
    DWORD    chSum;
public:
    CRS485Message();
    CRS485Message(CRS485Message* source);
    ~CRS485Message();

	BYTE	BadCRC;

    BYTE    GetAddress();
    void    SetAddress(BYTE newAddress);

    BYTE    GetID();
    void    SetID(BYTE newID);

    WORD    GetLen();

    BYTE*   GetData();
    void    SetData(UINT len, BYTE *buffer);

    DWORD    GetChSum();
    DWORD    CalcChSum();
};

#define _ID_COMMAND_INITIALIZE_     0x01
#define _ID_COMMAND_OPEN_DEVICE_    0x02
#define _ID_COMMAND_CLOSE_DEVICE_    0x03
#define _ID_COMMAND_SEND_DATA_      0x10
#define _ID_COMMAND_SEND_TEST_      0x11
#define _ID_COMMAND_SEND_DATA_RETRIEVE_      0x12
#define _ID_COMMAND_SEND_DATA_NEXT_		     0x13
#define _ID_COMMAND_GET_DATA_		     0x14

#define _ID_COMMAND_RELEASE_        0xFF


#define	_ID_SYSTEM_MAIN_WINDOW_ 		0x2000
#define	_ID_SYSTEM_MAIN_FUNCTION_		0x2001

#define _ID_RS485_MESSAGE_          WM_USER+0x2001
#define _ID_RS485_BUFFER_           WM_USER+0x2002
#define _ID_RS485_MESSAGE_WAITING_  WM_USER+0x2010

#define _ID_RS485_LOGGING_MESSAGE_	WM_USER+0x2200
#define _ID_RS485_DTR_				WM_USER+0x2201
#define _ID_RS485_RTS_				WM_USER+0x2202
#define _ID_RS485_TX_EMPTY_			WM_USER+0x2203



#endif
