#include "stdafx.h"
#include "comm485.h"

//---------------------------------------------------------------------------
//  Implementation
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//  CRS485Message
//---------------------------------------------------------------------------
CRS485Message::CRS485Message()
{
	Len = 0;
    Data = NULL;
    BadCRC = 0;
    FuncID = 0;
    chSum = 0;
}

CRS485Message::CRS485Message(CRS485Message* source)
{
	Len = 0;
    Data = NULL;
	SetData(source->GetLen(), source->GetData());
	SetID(source->GetID());
	SetAddress(source->GetAddress());
	BadCRC = source->BadCRC;
	CalcChSum();
}

CRS485Message::~CRS485Message()
{
    if(Data != NULL)
    {
        delete[] Data;
        Data = NULL;
    }
}

BYTE CRS485Message::GetAddress()
{
    return Address;
}

void CRS485Message::SetAddress(BYTE newAddress)
{
    Address = newAddress;
}

BYTE CRS485Message::GetID()
{
    return FuncID;
}
void CRS485Message::SetID(BYTE newID)
{
    FuncID = newID;
}

WORD CRS485Message::GetLen()
{
    return Len;
}

BYTE* CRS485Message::GetData()
{
    return Data;
}

void CRS485Message::SetData(UINT len, BYTE *buffer)
{
    if(Data != NULL)
        delete[] Data;

    if(len > 0 && buffer != NULL)
    {
	    Len = len;
        Data = new BYTE[len];
        memcpy(Data, buffer, len);
    }
    else
    {
	    Len = 0;
        Data = NULL;
    }
}

DWORD CRS485Message::GetChSum()
{
    return chSum;
}

DWORD CRS485Message::CalcChSum()
{
		chSum = 0;
		if(Data != NULL)
		{
			for(WORD i=0;i<Len;i++)
				chSum+=(DWORD)(Data[i]);
		}

    return chSum;
}
//---------------------------------------------------------------------------

