// rs485.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "rs485.h"
#include "comm485.h"
#include "RS485Form.h"
#include "\cpp\commands.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//
//	Note!
//
//		If this DLL is dynamically linked against the MFC
//		DLLs, any functions exported from this DLL which
//		call into MFC must have the AFX_MANAGE_STATE macro
//		added at the very beginning of the function.
//
//		For example:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// normal function body here
//		}
//
//		It is very important that this macro appear in each
//		function, prior to any calls into MFC.  This means that
//		it must appear as the first statement within the 
//		function, even before any object variable declarations
//		as their constructors may generate calls into the MFC
//		DLL.
//
//		Please see MFC Technical Notes 33 and 58 for additional
//		details.
//

/////////////////////////////////////////////////////////////////////////////
// CRs485App

BEGIN_MESSAGE_MAP(CRs485App, CWinApp)
	//{{AFX_MSG_MAP(CRs485App)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRs485App construction

CRs485App::CRs485App()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CRs485App object

CRs485App theApp;
CRS485Form	*rs485Form=NULL;

FUNCTION1   MainFunction=NULL;
HWND		MainWindow=NULL;
char        Dir[_MAX_DIR];
int         ComPort=1;
BYTE        Address=0;
int _BYTES_TO_LEN_ = 1;

bool	SendDebugInfo=false;

BOOL CRs485App::InitInstance() 
{
        	char    drive[_MAX_DRIVE],dir[_MAX_DIR],fname[_MAX_FNAME],ext[_MAX_EXT];
        	char    path[_MAX_PATH];

        	GetModuleFileName(0,path,_MAX_PATH);
        	_splitpath( path, drive, dir, fname, ext );
        	dir[strlen(dir)-1]=0;
        	sprintf(Dir,"%s%s",drive,dir);
	
	return CWinApp::InitInstance();
}

int CRs485App::ExitInstance() 
{
	if(rs485Form!=NULL)
	{
		rs485Form->DestroyWindow();
		delete rs485Form;
		rs485Form = NULL;
		MainFunction=NULL;
		MainWindow=NULL;
	}
	
	return CWinApp::ExitInstance();
}


//---------------------------------------------------------------------------
extern "C" __declspec(dllexport) UINT Comm485(UINT command, UINT Param)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
    switch(command)
    {
    case _ID_SYSTEM_MAIN_WINDOW_:
    	MainWindow = (HWND)Param;
if(MainWindow != NULL && SendDebugInfo)
{
char string[128];
   	sprintf(string, "_ID_SYSTEM_MAIN_WINDOW_");
	::SendMessage(MainWindow, _ID_RS485_LOGGING_MESSAGE_, (WPARAM)string, (LPARAM)strlen(string));
}
    	return 0;
    case _ID_SYSTEM_MAIN_FUNCTION_:
        MainFunction = (FUNCTION1)Param;
        return 0;
    case _ID_COMMAND_INITIALIZE_:
        {
if(MainWindow != NULL && SendDebugInfo)
{
char string[128];
   	sprintf(string, "_ID_COMMAND_INITIALIZE_");
	::SendMessage(MainWindow, _ID_RS485_LOGGING_MESSAGE_, (WPARAM)string, (LPARAM)strlen(string));
}
            if(rs485Form != NULL)
                return -1;

			CString ProFile = CString(Dir)+CString("\\pilabserver.ini");
//            Port = GetPrivateProfileInt("SYSTEM","Port",1,ProFile);
            ComPort = GetPrivateProfileInt("SYSTEM","ComPort",1,ProFile);
            Address = (BYTE)GetPrivateProfileInt("SYSTEM","Address",0,ProFile);
			_BYTES_TO_LEN_ = GetPrivateProfileInt("SYSTEM","BytesToLen",1,ProFile);

            if(rs485Form == NULL)
            {
                rs485Form = new CRS485Form();
				if((rs485Form->CDialog::Create(IDD_RS485FORM_DIALOG, NULL))==FALSE)
				{
if(MainWindow != NULL && SendDebugInfo)
{
char string[128];
   	sprintf(string, "rs485Form->CDialog::Create(IDD_RS485FORM_DIALOG, NULL) == NULL");
	::SendMessage(MainWindow, _ID_RS485_LOGGING_MESSAGE_, (WPARAM)string, (LPARAM)strlen(string));
}
					return -1;
				}
                rs485Form->RSBuffer.Clear();
				char pn[5];
				sprintf(pn, "COM%d", ComPort);
//		::MessageBox(NULL, pn, "Port", MB_OK);
                rs485Form->PortName = CString(pn);
                rs485Form->ComPort = ComPort;
                rs485Form->MyAddress = Address;
                if(!rs485Form->OpenPort())
				{
if(MainWindow != NULL && SendDebugInfo)
{
char string[128];
   	sprintf(string, "rs485Form->OpenPort() == false");
	::SendMessage(MainWindow, _ID_RS485_LOGGING_MESSAGE_, (WPARAM)string, (LPARAM)strlen(string));
}
					delete rs485Form;
					rs485Form = NULL;
					return -1;
				}
                rs485Form->RTS = true;
            }

        }
        return 0;
    case _ID_COMMAND_OPEN_DEVICE_:
        {
            if(rs485Form != NULL)
            {

				CRS485Device *newDevice = new CRS485Device();

				newDevice->Address = (BYTE)Param;

                rs485Form->Devices.Add(newDevice);
            }
        }
        return 0;
    case _ID_COMMAND_CLOSE_DEVICE_:
        {
            if(rs485Form != NULL)
            {
	        	int index = rs485Form->Devices.FindIndex((BYTE)Param);
		        if(index != -1)
			    {
					CRS485Device *Device = rs485Form->Devices.Item(index);
					if(Device->Timer)
					{
						rs485Form->RTS = true;
					}
					delete rs485Form->Devices.Item(index);
					rs485Form->Devices.Delete(index);
					return 0;
				}
				else
					return -1;
			}
			else
				return -1;
        }
    case _ID_COMMAND_SEND_DATA_:
        {
            if(rs485Form != NULL)
            {
				CRS485Message *newMessage = new CRS485Message((CRS485Message*)Param);
	        	bool res = rs485Form->Send(newMessage);
		        if(res)
			    	return 0;
				else
            		return -1;
			}
			else
				return -1;
        }
    case _ID_COMMAND_SEND_DATA_RETRIEVE_:
        {
        	bool res = rs485Form->Send((BYTE)Param);
            if(res)
            	return 0;
            else
            	return -1;
        }
    case _ID_COMMAND_SEND_DATA_NEXT_:
        {
        	bool res = rs485Form->SendNext((BYTE)Param);
            if(res)
            	return 0;
            else
            	return -1;
        }
    case _ID_COMMAND_SEND_TEST_:
        {
            if(rs485Form != NULL)
            {
	        	CRS485Message *mes = new CRS485Message();
		        mes->SetID(cmTEST);
			    mes->SetAddress((BYTE)Param);
        		return rs485Form->SendWait(mes);
//	        	return rs485Form->Send(mes);
			}
			else
				return -1;
        }
    }

    return -1;
}
//---------------------------------------------------------------------------
