// ClientSocket.cpp : implementation file
//

#include "stdafx.h"
#include "tcpclient.h"
#include "ClientSocket.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CClientSocket

extern	UINT	LastSocketId;

CClientSocket::CClientSocket()
{
	SocketOnAccept = NULL;
	SocketOnClose = NULL;
	SocketOnConnect = NULL;
	SocketOnReceive = NULL;
	SocketOnSend = NULL;
	SocketOnError = NULL;

	ProcessFunction = NULL;

	SocketId = ++LastSocketId;
}

CClientSocket::~CClientSocket()
{
	InBuffer.Clear();
	OutBuffer.Clear();
}


// Do not edit the following lines, which are needed by ClassWizard.
#if 0
BEGIN_MESSAGE_MAP(CClientSocket, CSocket)
	//{{AFX_MSG_MAP(CClientSocket)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif	// 0

/////////////////////////////////////////////////////////////////////////////
// CClientSocket member functions

void CClientSocket::OnClose(int nErrorCode) 
{
	if(nErrorCode == 0)
	{
		if(SocketOnClose != NULL)
			SocketOnClose(this);
	}
	else
	{
		if(SocketOnError != NULL)
			SocketOnError(this, nErrorCode, NULL);
	}
	
	CSocket::OnClose(nErrorCode);
}

void CClientSocket::OnConnect(int nErrorCode) 
{
	if(nErrorCode == 0)
	{
		if(SocketOnConnect != NULL)
			SocketOnConnect(this);
	}
	else
	{
		if(SocketOnError != NULL)
			SocketOnError(this, nErrorCode, NULL);
	}
	
	CSocket::OnConnect(nErrorCode);
}

void CClientSocket::OnReceive(int nErrorCode) 
{
	if(nErrorCode == 0)
	{
		if(SocketOnReceive != NULL)
			SocketOnReceive(this);
	}
	else
	{
		if(SocketOnError != NULL)
			SocketOnError(this, nErrorCode, NULL);
	}
	
	CSocket::OnReceive(nErrorCode);
}

void CClientSocket::OnSend(int nErrorCode) 
{
	if(nErrorCode == 0)
	{
		if(SocketOnSend != NULL)
			SocketOnSend(this);
	}
	else
	{
		if(SocketOnError != NULL)
			SocketOnError(this, nErrorCode, NULL);
	}
	
	CSocket::OnSend(nErrorCode);
}
