#include "stdafx.h"

#include "socketCallbacks.h"
#include "Sockets.h"
#include "\cpp\tcpdata.h"

#if !defined(_BLOCK_SIZE_)
#define	_BLOCK_SIZE_	4096
#endif

extern CClientSockets	*ClientSockets;

void CALLBACK OnSocketClose(LPVOID Sender)
{
	int index = ClientSockets->FindIndex((CClientSocket*)Sender);
	if(index != -1)
	{
		if( ((CClientSocket*)Sender)->ProcessFunction != NULL)
		{
			((CClientSocket*)Sender)->ProcessFunction(((CClientSocket*)Sender)->SocketId, _ID_TCP_MESSAGE_DISCONNECTED_);
		}
		ClientSockets->Delete(index);
	}
}

void CALLBACK OnSocketConnect(LPVOID Sender)
{
		if( ((CClientSocket*)Sender)->ProcessFunction != NULL)
		{
			((CClientSocket*)Sender)->ProcessFunction(((CClientSocket*)Sender)->SocketId, _ID_TCP_MESSAGE_CONNECTED_);
		}
}

void CALLBACK OnSocketReceive(LPVOID Sender)
{
	CClientSocket *Socket = (CClientSocket*)Sender;
//	if(Socket != NULL)
	{
		BYTE buffer[_BLOCK_SIZE_];
		int bytes = Socket->Receive(buffer,_BLOCK_SIZE_,0);

		Socket->InBuffer.Write(buffer, bytes);
		if( Socket->ProcessFunction != NULL)
		{
			Socket->ProcessFunction(Socket->SocketId, _ID_TCP_MESSAGE_);
		}
	}
}

void CALLBACK OnSocketSend(LPVOID Sender)
{
	CClientSocket *Socket = (CClientSocket*)Sender;
//	if(Socket != NULL)
	{
		BYTE buffer[_BLOCK_SIZE_];
		int len;
trytosend:
		len = Socket->OutBuffer.Peek(buffer,_BLOCK_SIZE_);
		if(len > 0)
		{
			if(Socket->Send(buffer,len,0) == len)
			{
				Socket->OutBuffer.Delete(len);
			}
			else
			{
				if(Socket->SocketOnError != NULL)
				{
					Socket->SocketOnError(Socket, Socket->GetLastError(), NULL);
					return;
				}
			
			}
		
			goto trytosend;
		}
	}
}

void  CALLBACK OnSocketError(LPVOID Sender, WORD Code, LPSTR Description)
{
		if( ((CClientSocket*)Sender)->ProcessFunction != NULL)
		{
			TCPErrorStruct ErrorStruct;
			ErrorStruct.Description = new char[255];
			switch(Code)
			{
			case 0:
				ErrorStruct.Code = 0;
				sprintf(ErrorStruct.Description, "No error.");
				break;
			case WSAENETDOWN:
				ErrorStruct.Code = _ID_TCP_ERROR_WSAENETDOWN_;
				sprintf(ErrorStruct.Description, "The Windows Sockets implementation detected that the network subsystem failed.");
				break;
			case WSAECONNRESET:
				ErrorStruct.Code = _ID_TCP_ERROR_WSAECONNRESET_;
				sprintf(ErrorStruct.Description, "The connection was reset by the remote side.");
				break;
			case WSAECONNABORTED:
				ErrorStruct.Code = _ID_TCP_ERROR_WSAECONNABORTED_;
				sprintf(ErrorStruct.Description, "The connection was aborted due to timeout or other failure.");
				break;
			}
			((CClientSocket*)Sender)->ProcessFunction(_ID_TCP_ERROR_, (UINT)(&ErrorStruct));
			delete ErrorStruct.Description;
		}
}